 /**
 *  Java binding for libGlass
 *  Copyright (C) 2003,2004
 *  Bruno Barberi Gnecco and Marcelo de Paiva Guimaraes
 *  Copyright (C) 2005-2010 Corollarium Tecnologia
 * 
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License as published by the Free Software Foundation; either
 *  version 2 of the License, or (at your option) any later version.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 */

#include "Glass_UnixSocket.h"
#include "glassjava.h"

/*
 * Class:     Glass_UnixSocket
 * Method:    createUnixSocket
 * Signature: ()J
 */
JNIEXPORT jlong JNICALL Java_Glass_UnixSocket_createUnixSocket
  (JNIEnv *jenv, jobject jobj) {
	UnixSocket *t;
	
	try {
		t = new UnixSocket();
	}
	catch (Exception e) {
		jclass except = jenv->FindClass("java/lang/Exception");
		if (except != 0) {
			jenv->ThrowNew(except, e.getMessage().c_str());
		}
		return 0;
	}

	return (jlong)t;
}

/*
 * Class:     Glass_UnixSocket
 * Method:    destroyUnixSocket
 * Signature: ()V
 */
JNIEXPORT void JNICALL Java_Glass_UnixSocket_destroyUnixSocket
  (JNIEnv *jenv, jobject jobj) {
	UnixSocket *t;
	jfieldID fid;
	jclass cls = jenv->GetObjectClass(jobj);

	fid = jenv->GetFieldID(cls, "pointer", "J");
   	if (fid == NULL) {
		return;
	}
	t = (UnixSocket *)jenv->GetLongField(jobj, fid);
	delete t;
}
