 /**
  *  Java binding for libGlass
  *  Copyright (C) 2003-2010
  *  Corollarium Technologies
  * 
  *  This library is free software; you can redistribute it and/or
  *  modify it under the terms of the GNU Lesser General Public
  *  License as published by the Free Software Foundation; either
  *  version 2 of the License, or (at your option) any later version.
  *
  *  This library is distributed in the hope that it will be useful,
  *  but WITHOUT ANY WARRANTY; without even the implied warranty of
  *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
  *  Lesser General Public License for more details.
  *
  *  You should have received a copy of the GNU Lesser General Public
  *  License along with this library; if not, write to the Free Software
  *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
  *
  *  @author      Corollarium Technologies
  *  @version     %I%, %G%
  *  @since       1.0
  */

package Glass;

public final class nodeId {

	/**
	 * Id for "nobody".
	 */
	public static final nodeId nobodyId = new nodeId(0);

	/**
	 * Id for "everybody" (broadcast).
	 */
	public static final nodeId everybodyId = new nodeId(1);

	/**
	 * Id for servers.
	 */
	public static final nodeId serversId = new nodeId(2);

	/**
	 * Id for clients.
	 */
	public static final nodeId clientsId = new nodeId(3);

	/**
	 * Id for peers.
	 */
	public static final nodeId peersId = new nodeId(4);

	/**
	 * Maximum id available.
	 */
	public static final nodeId maxId = new nodeId(Integer.MAX_VALUE);


	private int id;

	public nodeId(int id) {
		this.id = id;
	}
	public int getId() {
		return id;
	}
	public void setId(int id) {
		this.id = id;
	}

	public boolean equals(Object obj) {
		if (this == obj) {
			return true;
		}
		if (obj instanceof nodeId) {
			nodeId id = (nodeId)obj;
			if (id.id == this.id) {
				return true;
			}
		}
		return false;
	}
}
