 /**
  *  Java binding for libGlass
  *  Copyright (C) 2003-2010
  *  Corollarium Technologies
  * 
  *  This library is free software; you can redistribute it and/or
  *  modify it under the terms of the GNU Lesser General Public
  *  License as published by the Free Software Foundation; either
  *  version 2 of the License, or (at your option) any later version.
  *
  *  This library is distributed in the hope that it will be useful,
  *  but WITHOUT ANY WARRANTY; without even the implied warranty of
  *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
  *  Lesser General Public License for more details.
  *
  *  You should have received a copy of the GNU Lesser General Public
  *  License along with this library; if not, write to the Free Software
  *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
  *
  *  @author      Corollarium Technologies
  *  @version     %I%, %G%
  *  @since       1.0
  */

package Glass;

public class nodeRelation {
	private String id;
	public final int ord;
	private nodeRelation prev;
	private nodeRelation next;
	
	private static int upperBound = 0;
	private static nodeRelation first = null;
	private static nodeRelation last = null;

	private nodeRelation(String anID) {
		this.id = anID;
		this.ord = upperBound++;
		if (first == null) {
			first = this;
		}
		if (last != null) {
			this.prev = last;
			last.next = this;
		}
		last = this;
	}

	public String toString() { return this.id; }
	public static int size() { return upperBound; }
	public static nodeRelation first() { return first; }
	public static nodeRelation last()  { return last;  }
	public nodeRelation prev()  { return this.prev; }
	public nodeRelation next()  { return this.next; }

	public final static nodeRelation None = 
		new nodeRelation("None");
	public final static nodeRelation Server = 
		new nodeRelation("Server");
	public final static nodeRelation Client = 
		new nodeRelation("Client");
	public final static nodeRelation Peer = 
		new nodeRelation("Peer");
}
