/**
 *  Java binding for libGlass
 *  Copyright (C) 2003-2010
 *  Corollarium Technologies
 * 
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License as published by the Free Software Foundation; either
 *  version 2 of the License, or (at your option) any later version.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 *  @author      Corollarium Technologies
 *  @version     %I%, %G%
 *  @since       1.0
 */

import Glass.*;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.Set;  

class TestAlias {

	public static void main(String[] args) {
		HashMap<nodeId, nodeNickName> map = new HashMap<nodeId, nodeNickName>();

		/*
		 * Setup client 
		 */
		String server;
		if (args.length == 0) {
			server = "localhost";
		}
		else {
			server = args[0];
		}
		System.out.println("Connecting to: " + server);

		GlassClient g = null;
		try {
			g = new GlassClient(new TCP(), server, "", false);
		} catch(GlassException e){
			System.out.println("Error: Client initialization: "+ e);
			return;
		}

		Alias<Integer> alias;
		Barrier b;
		try {
			alias = new Alias<Integer>("integer", 1);
			b = new Barrier(0, 0, true);
		} catch(GlassException e){
			System.out.println("Error: Client initialization: "+ e);
			return;
		}
		alias.addAlias("one", 1);
		alias.addAlias("two", 2);
		alias.addAlias("three", 3);
		alias.addAlias("four", 4);
		alias.addAlias("five", 5);		

		while (true) {
			if (g.isMaster()) {
				System.out.println("I am Master");
				map = g.getClientList();
				//				int clients[] = g.getClientList();
				//				for (int i = 0; i < clients.length; i++) { 
				//					System.out.println("Client "+i+" Node: "+clients[i]);
				//					if (i == 0) {
				//						alias.associate(clients[i], "one");
				//					} else if (i == 1) {
				//						alias.associate(clients[i], "two");
				//					} else if (i == 2) {
				//						alias.associate(clients[i], "three");
				//					} else if (i == 3) {
				//						alias.associate(clients[i], "four");
				//					} else {
				//						alias.associate(clients[i], "five");
				//					}				    
				//				}

				int i = 0;
				for (nodeNickName nick  : map.values()) {  
					System.out.println("Client "+i+" Node: "+ nick.getNick());
				
					i++;
				}
			}else{
				System.out.println("I am not Master");
			}

			try { Thread.sleep(1000); } catch(InterruptedException e) { }

			int data = alias.getData();
			System.out.println("Node: " + g.getNodeId() + ", value: " + data);
		}
	}
}

