 /**
  *  Java binding for libGlass
  *  Copyright (C) 2003-2010
  *  Corollarium Technologies
  * 
  *  This library is free software; you can redistribute it and/or
  *  modify it under the terms of the GNU Lesser General Public
  *  License as published by the Free Software Foundation; either
  *  version 2 of the License, or (at your option) any later version.
  *
  *  This library is distributed in the hope that it will be useful,
  *  but WITHOUT ANY WARRANTY; without even the implied warranty of
  *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
  *  Lesser General Public License for more details.
  *
  *  You should have received a copy of the GNU Lesser General Public
  *  License along with this library; if not, write to the Free Software
  *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
  *
  *  @author      Corollarium Technologies
  *  @version     %I%, %G%
  *  @since       1.0
  */

import Glass.*;

class TestBarrier {
	public static void main(String[] args) {
		Glass g = null;
		try {
			if (args.length == 0) {
				g = new GlassServer(new TCP());
			} else {				
				System.out.println("Connecting to: " + args[0]);
				g = new GlassClient(new TCP(), args[0],"", false);
			}
		} catch (GlassException e) {
			System.out.println("Error: Client initialization: " + e);
		}
		if (((GlassClient)g).isMaster()) {
			System.out.println("I am Master");
		} else {
			System.out.println("I am not Master");
		}
		System.out.println("Client started ");
		Barrier b;
		Barrier b2;
		int	i = 0;
		
		/* For first dish, a fresh Barrier. */
		try {
			System.out.println("Starting barries ");
			b = new Barrier(0);
			b2 = new Barrier(1);
		}
		catch (Exception e) {
			System.out.println("Error creating barrier");
			return;
		}
		System.out.println("Barries started ");
		if (((GlassClient)g).isMaster()) {
			System.out.println("I am Master");			
		}else{
			System.out.println("I am not Master");
		}
	
		/* The main course is 60 synchronizations of the barrier. */
		System.out.println("Starting. Waiting 10 seconds");
		try {
			Thread.sleep(1000);
		}
		catch (InterruptedException e) {		
		}

		while (true) {
			System.out.println("Locking! " +i);
			b.sync();
			try {
				Thread.sleep(1000);
			}
			catch (InterruptedException e) {		
			}
			b2.sync();
			i++;
		}
		
		// return;
	}
}
