/**
 *  Java binding for libGlass
 *  Copyright (C) 2003-2010
 *  Corollarium Technologies
 * 
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License as published by the Free Software Foundation; either
 *  version 2 of the License, or (at your option) any later version.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 *  @author      Corollarium Technologies
 *  @version     %I%, %G%
 *  @since       1.0
 */

import Glass.Event;
import Glass.GlassClient;
import Glass.TCP;

/*
 * NOTE TO DEVELOPERS:
 * 
 * This logic is not recommended in your code. It's only a test case.
 */
public class TestEvent2 {

	/**
	 * @param args
	 */
	public static void main(String[] args) throws Exception {
		GlassClient glassNode = new GlassClient(new TCP(), "localhost", "", false);
		Event<Integer> nodeToMaster = new Event<Integer>("nodeToMaster");
		Event<Integer> masterToNode = new Event<Integer>("masterToNode");
		boolean start = false;
		
		while (true) {
			if (glassNode.isMaster()) {
				// aguarda o outro node iniciar

				System.out.println("saiu while 1");

				// aguarda a chegada do evento
				while (nodeToMaster.isEmpty()) {
					
				}

				System.out.println("saiu while 2");

				// recebe evento
				int i = nodeToMaster.getEvent();
				System.out.println("nodeToMaster event: " + i);

				// envia varios eventos
				for (int j = 0; j < 100; j++) {
					System.out.println("enqueueing: " + j);
					masterToNode.enqueueEvent(j);
					Thread.sleep(1000);
				}

				// mantem o node master rodando
				while(true) {
					Thread.sleep(1000);					
				}

			} else {
				if (start == false) {
					start = true;
					// envia evento para o master
					nodeToMaster.enqueueEvent(123);
				}

				// aguarda eventos do master
				if (masterToNode.isEmpty()) {
					System.out.println("empty");
				}
				else {
					// tenta receber pelo menos 1 evento
					int i = masterToNode.getEvent();
					System.out.println("masterToNode event: " + i);
				}
			}
			Thread.sleep(1000);			
		}

	}
}