/*  Glass - a distributed computing library
    Copyright (C) 2003-2009 Bruno Barberi Gnecco
    Copyright (C) 2009-2010 Corollarium Technologies


    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Lesser General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public
    License along with this library; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

/******************************************************************************
Multiprojection example
                                                                                
Program description:
     JNI file used by the java interface to send commands to the
     Glass application
                                                                                
Dependencies:
                                                                                
Authors:
        Marcelo de Paiva Guimaraes <marcelopaivag@yahoo.com.br>
                                                                                
History:
        22 June 2003: Initial implementation (MPG)
                                                                                
Return codes:
0       Successful
                                                                                
***************************************************************************/

#include "libglass.h"
#include "integration.h"
#include <iostream>
using namespace libglass;
using std::cerr;
using std::endl;

static GlassClient *gc = NULL;
static Event<int,rawPack, rawUnpack> *event; 

void clickevent(char *host){
	try {
	     if (!gc) {
		   gc = new GlassClient(new TCP(),host); // server as argument
		   event  = new Event<int,rawPack, rawUnpack>("event");
	     }
	}catch (Exception *e)
       {
		printf("libGlass connection failed \n");
       }
}

void destroyevent(){
        delete gc;
}

void registerEvent(int number){
	event->enqueueEvent(number);
}
