/*  Glass - a distributed computing library
    Copyright (C) 2003-2009 Bruno Barberi Gnecco
    Copyright (C) 2009-2010 Corollarium Technologies


    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Lesser General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public
    License along with this library; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#ifndef _LIBGLASS_HH_
#define _LIBGLASS_HH_

#include "glassconfig.h"

// Microsoft Visual C compiler compatability
#include "msvc.h"

#include "types.h"
#include "exception.h"
#include "chain.h"
#include "serial.h"
#include "thread.h"

#include "memorymanager.h"
#include "interprocess.h"

#include "glass.h"
#include "glassclient.h"
#include "glassserver.h"
#include "glassserverpeer.h"

/* include our default protocols */
#include "protocol.h"
#include "tcp.h"
#include "unixsocket.h"
#include "tcpudp.h"
#ifdef HAVE_SCTP
#include "sctp.h"
#endif
//#include "udp.h"

/* include our default plugins */
#include "plugin.h"

#include "alias.h"
#include "barrier.h"
#include "event.h"
#include "shared.h"
#include "remotevar.h"

//DEPRECATED: #include "messenger.h"

/*! \mainpage libGlass

 \section Introduction

  libGlass is a library for distributed computing. For more information, see
  its <A HREF="http://libglass.sf.net/">homepage</a>.

 */

#endif
