/*  Glass - a distributed computing library
    Copyright (C) 2003-2009 Bruno Barberi Gnecco
    Copyright (C) 2009-2010 Corollarium Technologies


    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Lesser General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public
    License along with this library; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#ifndef _GLASS_PROTOCOL_TCPUDP_HH_
#define _GLASS_PROTOCOL_TCPUDP_HH_

#include <list>

#define GLASS_UDP_DEFAULT_PORT 9192

#include "tcp.h"

namespace libglass {

class PacketLog;

class LIBGLASS_API TCPUDP : public TCP {
protected:
	unsigned int listenportudp;		/**< udp listen port */
	int			listenfdudp;		/**< Listener socket. */
	int			udpoutsocket;

	int UDPreadPacket(Packet &p, nodeAddress &addr);
	unsigned int UDPwritePacket(const nodeAddress &addr, chain &m, unsigned int length);

	/**
	 * @param port This argument is ignored. The value from the constructor is used instead.
	 * @see TCP::_listen
	 */
	virtual int _listen(unsigned int port);

#if 0
	/**
	 * @param port This argument is ignored. The value from the constructor is used instead.
	 * @see TCP::_listen
	 */
	virtual nodeAddress _connect(const char *host, unsigned int port);

	/**
	 * @param port This argument is ignored. The value from the constructor is used instead.
	 * @see TCP::_listen
	 */
	virtual nodeAddress _connect(const nodeAddress &host);
#endif

	virtual void _disconnect(nodeAddress &node);
	virtual bool _send(Packet &p);
	virtual int _recv(Packet &p);

public:
	TCPUDP(unsigned int porttcp = GLASS_TCP_DEFAULT_PORT, unsigned int portudp = GLASS_UDP_DEFAULT_PORT);
	virtual ~TCPUDP();
};

} //namespace

#endif // _GLASS_PROTOCOL_TCP_HH_
