/*  Glass - a distributed computing library
    Copyright (C) 2003-2009 Bruno Barberi Gnecco
    Copyright (C) 2009-2010 Corollarium Technologies


    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Lesser General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public
    License along with this library; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#ifndef _GLASS_THREAD_HH_
#define _GLASS_THREAD_HH_

#include <boost/thread.hpp>

namespace libglass {

/**
 * This is a simple wrapper for threads.
 */
class GlassThread {
public:
	explicit GlassThread(bool autostart = false) {
		if (autostart) {
			this->start();
		}
	}

	void start() {
		t = boost::thread(&GlassThread::execute, this);
	}

	virtual void execute() = 0;

	virtual void cleanup() = 0;

	void join() {
		t.join();
		cleanup();
	}

protected:
	boost::thread t;
};

}

#endif // _GLASS_SERIAL_HH_
