/*  Glass - a distributed computing library
    Copyright (C) 2003-2009 Bruno Barberi Gnecco
    Copyright (C) 2009-2010 Corollarium Technologies


    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Lesser General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public
    License along with this library; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#ifndef _GLASS_PROTOCOL_UNIXSOCKET_HH_
#define _GLASS_PROTOCOL_UNIXSOCKET_HH_

#include <list>

#include "tcp.h"

namespace libglass {

class PacketLog;

/**
 * Similar to TCP, but uses unix sockets instead.
 */
class LIBGLASS_API UnixSocket : public TCP {
protected:

	virtual int bind(int fd);

	virtual nodeId getUniqueId(void);
	virtual nodeAddress _connect(const nodeAddress &original);

public:
	UnixSocket();

	virtual ~UnixSocket();
};

} //namespace

#endif // _GLASS_PROTOCOL_UNIXSOCKET_HH_
