/*  Glass - a distributed computing library
    Copyright (C) 2003-2009 Bruno Barberi Gnecco
    Copyright (C) 2009-2010 Corollarium Technologies


    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Lesser General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public
    License along with this library; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#include "log.h"
#include "memorymanager.h"
#include <malloc.h>

using namespace libglass;

DefaultMemoryManager::DefaultMemoryManager() {

}

DefaultMemoryManager::~DefaultMemoryManager() {

}

void* DefaultMemoryManager::allocate(size_t nbytes, const std::string &identifier) {
	return malloc(nbytes);
}

void DefaultMemoryManager::deallocate(void *p) {
	free(p);
}

void* operator new(size_t nbytes, libglass::MemoryManager& pool, const std::string &identifier) {
	return pool.allocate(nbytes, identifier);
}

void operator delete(void* p, libglass::MemoryManager& pool) {
	pool.deallocate(p);
}
