#include <iostream>
#if !defined(_MSC_VER)
#  include <unistd.h> 
#endif // _MSC_VER
#include "libglass.h"

using namespace libglass;

using std::cout;
using std::cerr;
using std::endl;


#if defined(_MSC_VER)
#  define SLEEP(a) Sleep(a * 1000)
#else
#  define SLEEP(a) sleep(a)
#endif // _MSC_VER

#define WAIT 15 // seconds

int main(int argc, char **argv) {
	GlassClient		*g = NULL;

	try {
		if (argc == 1) {
			new GlassServer(new TCP());
		}
		else {
			g = new GlassClient(new TCP(), argv[1]);
		}
	}
	catch (Exception e) {
		cerr << e.getMessage() << endl;
		exit(1);
	}
	cout << "I am node " << g->getNodeId() << endl;
	if (g->isMaster()) {
		cout << "I am Master " << endl;
		// Pause
		SLEEP(WAIT); // seconds
		// Send kill packet
		cout << "Sending kill packet now" << endl;
		g->killAll();
	}
	else {
		cout << "I am not Master " << endl;
		// Loop forever
		while (true) {
			cout << "Waiting kill packet " << endl;
			SLEEP(1); // seconds
		}
	}

	return 0;
}
