/*  Glass - a distributed computing library
    Copyright (C) 2003-2009 Bruno Barberi Gnecco
    Copyright (C) 2009-2010 Corollarium Technologies


    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Lesser General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public
    License along with this library; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#include <iostream>
#include <stdio.h>
#include <stdlib.h>
#include "chain.h"

using std::cerr;
using std::endl;
using namespace libglass;

int testcmp(const char *received, int sizer, const char *expected, int sizee) {
	if (sizer != sizee)
		return 1;
	return memcmp(received, expected, sizee);
}

#define X() \
	cerr << "Test " << argv[1] << "/" << argv[2] << ": " << \
		t.size() << "," << end-begin+1 << endl; \
	for (i = 0; i < t.size(); i++) { \
		cerr << t[i] << " | " << expected[i+begin] << endl; \
	} \
	cerr << "------------" << endl;

int main(int argc, char *argv[]) {
	const char *expected = "AAAA\0BBBB\0CCCC\0DDDD\0EEEE\0FFFF";
	chain s, t;
	int begin, end;
	unsigned int i;
	if  (argc < 3){
	       printf("Usage: ./chainmanualtest begin end\n");
	       return 0;
	} 
	begin = atoi(argv[1]);
	end = atoi(argv[2]);

	s.clear();
	s.append("AAAA");
	s.append("BBBB");
	s.append("CCCC");
	s.append("DDDD");
	s.append("EEEE");
	s.append("FFFF");
	t = s.substr(begin, end);
	X();

	return 0;
}
