/*  Glass - a distributed computing library
    Copyright (C) 2003-2009 Bruno Barberi Gnecco
    Copyright (C) 2009-2010 Corollarium Technologies


    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Lesser General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public
    License along with this library; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#include "libglass.h"
#include <iostream>

using namespace libglass;

/*
 * arguments:
 *
 * peer [seedhost] [remoteport] [localport]
 */
int main(int argc, char **argv) {
	try {
		if (argc == 1) {
			TCP *tcp = new TCP();
			GlassServerPeer *g = new GlassServerPeer(tcp);
		}
		else if (argc == 2) {
			GlassServerPeer *g = new GlassServerPeer(new TCP(), argv[1]);
		}
		else if (argc == 4) {
			GlassServerPeer *g = new GlassServerPeer(new TCP(atoi(argv[3])), argv[1], atoi(argv[2]));
		}
		else {
			std::cerr << "peer [seedhost] [remoteport] [localport]" << std::endl;
		}
	}
	catch (Exception e) {
		std::cerr << e.getMessage() << std::endl;
		exit(1);
	}

	return 0;
}
