#include <iostream>
#include "libglass.h"

#if defined(_MSC_VER)
#  define SLEEP(a) Sleep(a * 1000)
#else
#  define SLEEP(a) sleep(a)
#endif // _MSC_VER


using namespace libglass;

using std::cout;
using std::cerr;
using std::endl;

#define DATA_TO_SHARE	15

int main(int argc, char **argv) {
	GlassClient	*g;
	Barrier		*b;
	int i = 0;

	try {
		if (argc == 1) {
			new GlassServer(new TCPUDP());
		}
		else {
			g = new GlassClient(new TCPUDP(), argv[1]);
		}
	}
	catch (Exception e) {
		cerr << e.getMessage() << endl;
		exit(1);
	}
	b = new Barrier(0,false);

	Shared<int, rawPack, rawUnpack> *sharedint = new Shared<int, rawPack, rawUnpack>("sharedint");
	cerr << "Value before update: " << sharedint->getData() << endl;
//	SLEEP(5); // seconds
	cout << "I am node " << g->getNodeId() << endl;

	while(i<=DATA_TO_SHARE) {
		if (g->isMaster()) {
			cout << "I am Master " << endl;
			// sharedint->assign(++i);
			*sharedint = ++i;
			cerr << "Updating sharedint..." << sharedint->getData() << endl;
			sharedint->sendUpdate();
			*sharedint = 0;
		}
		else{
			cout << "I am not Master " << endl;
		}
		b->sync();
		cerr << "getting update" << endl;
		sharedint->getUpdate();
//	_Shared::syncAll();
		cerr << "new value: " << sharedint->getData() << endl;
		SLEEP(1); // seconds
	}
	g->killAll();
//	SLEEP(5); // seconds

	delete sharedint;

	return 0;
}
