 /**
 *   GEditor - a interface generator for PDA Glass application
 * Marcelo de Paiva Guimaraes and Bruno Barberi Gnecco
 * Copyright (C) 2003,2004
 *
 *  It is part of Glass - a distributed computing library
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License as published by the Free Software Foundation; either
 *  version 2 of the License, or (at your option) any later version.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 *  @author      Marcelo de Paiva Guimaraes
 *  @version     %I%, %G%
 *  @since       1.0
 */
 import java.awt.*;
 import java.awt.event.*;
 import javax.swing.*;
 import java.util.*;
 import java.io.*;
 import javax.swing.tree.*;
 import javax.swing.event.*;
 import java.awt.image.*;
 import javax.swing.*;
 
 public class Editor extends JFrame  implements ActionListener,TreeSelectionListener{
	 static Editor editor;
	 JPanel JPanel_main,JPanel_tool;
	 JTabbedPane jTabbedPane = new JTabbedPane();
	 JScrollPane jScrollPane1 = new JScrollPane();
	 JScrollPane scrollPane;
	 JFileChooser fc = new JFileChooser();
	 
	 String skinnameselected=""; //skin name of the selected tab
	 int skincont=0;
	 int skinquant=0; // tab (skin) quantity
	 int objquant=0; // quantity of objects in current skin
	 boolean Project_isOpen=false; // true - there is a project opened
	 boolean clickedontree = false; // if is clicked on the tree or in draw area
	 boolean clickedonevent=false; // if is clicke on the event or in a hot spot the draw (tree area)
	 boolean hide_image=false;// if is false, so the imaged is hided
	 int WidthImageArea=240,HeightImageArea=320;
	 int RESIZE_TYPE=0;//O-NOTHING 1-left upper 2-right down 3-left down 4-right upper
	 int oldX,oldY;  // OLD MOUSE POSITION
	 int STATE=0;//0-NOTHING  1-OBJECT SELECTED 2-OBJECT SELECTED FOR RESIZE
	 
	 JToggleButton jButton_Seleciona,jButton_Rectangle,jButton_Ellipse,jButton_Image,jButton_Generate,jButton_Hide;
	 JButton jButton_exit;
	 JMenuBar jMenuBar1;
	 JMenu File,Configure,Glass,Type;
	 ButtonGroup groupType;
	 JMenuItem JMenuItem_Open,JMenuItem_Save,JMenuItem_About,JMenuItem_Skin;
	 
	 JRadioButtonMenuItem simpleType,exitType,skinType,positionType;
	 JMenuItem JMenuItem_TypeSimple,JMenuItem_TypeExit,JMenuItem_TypeSkin,JMenuItem_DeleteSkin;
	 JMenuItem JMenuItem_New,JMenuItem_Close,JMenuItem_Delete,EventValue,JMenuItem_Environment;
	 JMenuItem JMenuItem_AddAll,JMenuItem_DeleteAll,JMenuItem_SkinName,JMenuHotSpot_Event;
	 
	 JLabel  JLabel_toolbox,JLabel_hotspot;
	 Vector gdraw; // stores the project data (all information - image, tab, ....)
	 Vector draw; // used to store actual tab objects (0-skin,1-image name,2-scroll object and objects -rectangles and elipse-)
	 Vector eventlist;
	 Forma CurrentObject = null;
	 EventType currentevent;
	 Generate generate;
	 Toolkit toolkit = Toolkit.getDefaultToolkit();
	 String Imagename="";
	 Image imagem = toolkit.getImage(Imagename);
	 Image img;
	 ProjectName projectname;
	 JTree	tree;
	 DefaultMutableTreeNode root,itemEvent,itemDraw;
	 DefaultTreeModel treeModel;
	 JPopupMenu popup,popup2;
	 JPanel jPanel_tree;
	 GlassEvent glassevent;
	 GlassHotspot glasshotspot;
	 GlassTab glasstab;
	 GlassEnvironment environment;
	 GlassSkinName skinname;
	 Graphics g1,g2;
	 SymMouse aSymMouse;
	 SymMouseMotion aSymMouseMotion;
	 MouseListener popupListener;
	 boolean firsttime=true;
	 
	 
	 //Construct the frame
	 public Editor() {
		 enableEvents(AWTEvent.WINDOW_EVENT_MASK);
		 try {
			 jbInit();
		 } catch(Exception e) {
			 e.printStackTrace();
		 }
	 }
	 //Component initialization
	 private void jbInit() throws Exception	 {
		 glasstab = new GlassTab(this);
		 glassevent = new GlassEvent(this);
		 glasshotspot = new GlassHotspot(this);
		 generate = new Generate();
		 environment = new GlassEnvironment(this);
		 skinname = new GlassSkinName(this);
		 projectname= new ProjectName(this);
		 JPanel_main = (JPanel) this.getContentPane();
		 JPanel_main.setLayout(null);
		 this.setSize(new Dimension(525,460));
		 this.setTitle("Interface Generator - Glass Tool");
		 fc.setCurrentDirectory(new File("../projects"));
		 // - label
		 JLabel_toolbox = new JLabel();
		 JLabel_toolbox.setBounds(20,2,70,50);
		 JLabel_toolbox.setText("Tool Box");
		 getContentPane().add(JLabel_toolbox);
		 JLabel_hotspot = new JLabel();
		 JLabel_hotspot.setBounds(365,2,170,50);
		 JLabel_hotspot.setText("Events x Hots Spots");
		 getContentPane().add(JLabel_hotspot);
		 // - tool panel - begin
		 JPanel_tool = new JPanel();
		 JPanel_tool.setBounds(3,42,96,335);
		 JPanel_tool.setBackground(new Color(12632256));
		 getContentPane().add(JPanel_tool);
		 jButton_Seleciona = new JToggleButton();
		 Icon gif1 = new ImageIcon (this.getClass().getResource("icons/seleciona.gif"));
		 jButton_Seleciona.setIcon (gif1);
		 jButton_Seleciona.setBounds(18,5,35,11);
		 jButton_Seleciona.setToolTipText("Select a Hot Spot");
		 jButton_Seleciona.setSelected(true);
		 JPanel_tool.add(jButton_Seleciona);
		 jButton_Rectangle = new JToggleButton();
		 jButton_Rectangle.setBounds(18,37,35,11);
		 jButton_Rectangle.setToolTipText("Rectangle Hot Spot");
		 Icon gif2 = new ImageIcon (this.getClass().getResource("icons/retangulo.gif"));
		 jButton_Rectangle.setIcon (gif2);
		 JPanel_tool.add(jButton_Rectangle);
		 jButton_Ellipse = new JToggleButton();
		 jButton_Ellipse.setBounds(18,53,35,11);
		 jButton_Ellipse.setToolTipText("Ellipse Hot spot");
		 Icon gif3 = new ImageIcon (this.getClass().getResource("icons/circulo.gif"));
		 jButton_Ellipse.setIcon (gif3);
		 JPanel_tool.add(jButton_Ellipse);
		 jButton_Image = new JToggleButton();
		 jButton_Image.setBounds(18,69,35,11);
		 jButton_Image.setToolTipText("Load the Skin Image");
		 Icon gif4 = new	ImageIcon(this.getClass().getResource("icons/image.gif"));
		 jButton_Image.setIcon (gif4);
		 JPanel_tool.add(jButton_Image);
		 jButton_Generate = new JToggleButton();
		 jButton_Generate.setBounds(18,78,35,11);
		 jButton_Generate.setToolTipText("Generate the c code");
		 Icon gif5 = new ImageIcon (this.getClass().getResource("icons/palm.gif"));
		 jButton_Generate.setIcon (gif5);
		 JPanel_tool.add(jButton_Generate);		 
		 jButton_Hide = new JToggleButton();
		 jButton_Hide.setBounds(18,87,35,11);
		 jButton_Hide.setToolTipText("Hide/Show the Image");
		 Icon gif6 = new ImageIcon (this.getClass().getResource("icons/eye.gif"));
		 jButton_Hide.setIcon (gif6);
		 JPanel_tool.add(jButton_Hide);
		 // - tool panel - end
		 Principal_menu();
		 popup = new JPopupMenu();
		 popup2 = new JPopupMenu();
		 // button used to change event features
		 EventValue = new JMenuItem("Events");
		 EventValue.addActionListener(this);
		 popup.add(EventValue);
		 popup.addSeparator();
		 // button used to associate a hot spot with a event
		 JMenuHotSpot_Event = new JMenuItem("Hot Spot Association Event");
		 JMenuHotSpot_Event.addActionListener(this);
		 popup.add(JMenuHotSpot_Event);		 
		 // hot spot type
		 Type = new JMenu("Hot Spot Type");
		 groupType = new ButtonGroup();
		 // hot spot type
		 simpleType = new JRadioButtonMenuItem("Simple");
		 simpleType.setSelected(true);
		 simpleType.addActionListener(this);
		 groupType.add(simpleType);
		 Type.add(simpleType);
		 // hot spot type
		 exitType = new JRadioButtonMenuItem("Exit");
		 exitType.addActionListener(this);
		 groupType.add(exitType);
		 Type.add(exitType);
		 // hot spot type
		 skinType = new JRadioButtonMenuItem("Skin");
		 skinType.addActionListener(this);
		 groupType.add(skinType);
		 Type.add(skinType);
		 // hot spot type
		 positionType = new JRadioButtonMenuItem("Position");
		 positionType.addActionListener(this);
		 groupType.add(positionType);
		 Type.add(positionType);		 
		 popup.add(Type);
		 //button used to add the current hot spon on all skins
		 JMenuItem_AddAll= new JMenuItem("Add on All Skins");
		 JMenuItem_AddAll.addActionListener(this);
		 popup.add(JMenuItem_AddAll);
		 //button used to delete the current hot spot
		 JMenuItem_Delete = new JMenuItem("Delete this Hot Spot  ");
		 JMenuItem_Delete.addActionListener(this);
		 popup.add(JMenuItem_Delete);
		 // button used to delete the current hot spot of all skins
		 JMenuItem_DeleteAll= new JMenuItem("Delete of All Skins");
		 JMenuItem_DeleteAll.addActionListener(this);
		 popup.add(JMenuItem_DeleteAll);		 
		 popup.addSeparator();
		 // button used to add a new skin
		 JMenuItem_Skin = new JMenuItem("New Skin");
		 JMenuItem_Skin.addActionListener(this);
		 popup.add(JMenuItem_Skin);
		 // button used to delete the current skin
		 JMenuItem_DeleteSkin = new JMenuItem("Delete this Skin");
		 JMenuItem_DeleteSkin.addActionListener(this);
		 popup.add(JMenuItem_DeleteSkin);
		 // - button used to change the skin name
		 JMenuItem_SkinName = new JMenuItem("Change the Skin Name");
		 JMenuItem_SkinName.addActionListener(this);
		 popup.add(JMenuItem_SkinName);		 
		 // - exit button
		 jButton_exit = new JButton();
		 jButton_exit.setText("EXIT");
		 jButton_exit.setBounds(405,HeightImageArea+25,99,31);
		 jButton_exit.setFont(new Font("Dialog", Font.BOLD, 12));
		 jButton_exit.addActionListener(this);
		 getContentPane().add(jButton_exit);
		 // - event listening
		 aSymMouse = new SymMouse();
		 //jScrollPane1.addMouseListener(aSymMouse);
		 SymAction lSymAction = new SymAction();
		 jButton_Seleciona.addActionListener(lSymAction);
		 jButton_Rectangle.addActionListener(lSymAction);
		 jButton_Ellipse.addActionListener(lSymAction);
		 jButton_Generate.addActionListener(lSymAction);
		 jButton_Image.addActionListener(lSymAction);
		 jButton_Hide.addActionListener(lSymAction);
		 aSymMouseMotion = new SymMouseMotion();
		 
		 popupListener = new PopupListener();
		 popup.addMouseListener(popupListener);
		 // - initialize
		 gdraw = new Vector();
		 draw=new Vector();
		 eventlist = new Vector();
		 root = new DefaultMutableTreeNode( "Glass Tool              " );
		 //  tree
		 jPanel_tree = new JPanel(true);
		 jPanel_tree.setBounds(110+WidthImageArea+7,42,155,320);
		 jPanel_tree.setBackground(new Color(12632256));
		 getContentPane().add(jPanel_tree,BorderLayout.CENTER);
		 treeModel = new DefaultTreeModel( root ); // Create a new tree control
		 tree = new JTree(treeModel);
		 tree.addTreeSelectionListener(this);
		 tree.addMouseListener(popupListener);
		 scrollPane = new JScrollPane(); 	// Add the listbox to a scrolling pane
		 scrollPane.setVerticalScrollBarPolicy(JScrollPane.VERTICAL_SCROLLBAR_ALWAYS);
		 scrollPane.setHorizontalScrollBarPolicy(JScrollPane.HORIZONTAL_SCROLLBAR_ALWAYS);
		 scrollPane.setPreferredSize(new Dimension(150, 310));
		 tree.setBounds(525-168,12,155,220);
		 scrollPane.setViewportView(tree);
		 jPanel_tree.add(scrollPane,BorderLayout.CENTER);
		 //  - tab
		 // java bug - scrolls the tabs on single line
		 // if enabled, the mouse listening does not work in the tabs
		 //jTabbedPane.setTabLayoutPolicy(JTabbedPane.SCROLL_TAB_LAYOUT);
		 //jTabbedPane.setBounds(110,12,WidthImageArea,HeightImageArea+30);
		 jTabbedPane.setBackground(new Color(12632256));
		 JPanel_main.add(jTabbedPane, null);
		 SymMouse2 bSymMouse = new SymMouse2();
		 jTabbedPane.addMouseListener(bSymMouse);
		 disablePanel();
		 g1 = jScrollPane1.getGraphics();
		 Resize_App();
		 
		 
		 //Center the window
		 Dimension screenSize = Toolkit.getDefaultToolkit().getScreenSize();
		 Dimension frameSize = this.getSize();
		 if (frameSize.height > screenSize.height) {
			 frameSize.height = screenSize.height;
		 }
		 if (frameSize.width > screenSize.width) {
			 frameSize.width = screenSize.width;
		 }
		 this.setLocation((screenSize.width - frameSize.width) / 2, (screenSize.height - frameSize.height) / 2);
		 this.setResizable(false);
		 setVisible(true);
		 
		 
	 }
	 //File | Exit action performed
	 public void jMenuFileExit_actionPerformed(ActionEvent e) {
		 System.exit(0);
	 }
	 //Overridden so we can exit when window is closed
	 protected void processWindowEvent(WindowEvent e) {
		 super.processWindowEvent(e);
		 if (e.getID() == WindowEvent.WINDOW_CLOSING)	 {
			 jMenuFileExit_actionPerformed(null);
		 }
	 }
	 //-------------------
	 public void paint(Graphics g){
		 update(g);
	 }
	 //------------------------
	 public void update( Graphics g ) {
		 super.paint(g);
		 if (g1!=null)	 {
			 if (firsttime){
				 g1 = jScrollPane1.getGraphics();
				 if (!hide_image){
					 g1.drawImage(imagem, 0, 0,this);
				 }
				 Enumeration e = draw.elements();
				 Forma tmp;
				 if (e.hasMoreElements()) {
					 e.nextElement(); // skip the skin name
					 e.nextElement(); // skip the image name
					 e.nextElement(); // skip the scroll object
				 }
				 while( e.hasMoreElements() ) {
					 tmp = (Forma) e.nextElement();
					 tmp.Desenha(g1);
					 if (tmp.eventtype==2)
						 g1.drawString(tmp.eventtab,tmp.x1+05, tmp.y1+10);
				 }
			 }
		 }
		 if (!firsttime)
			 super.paint(g1);		 
	 }
	 // - main
	 public	static void main(String args[] ){
		 editor = new Editor();
	 }
	 // -----
	 public void updatedObjectTab(String xtab){
		 CurrentObject.eventtype=2;
		 CurrentObject.eventtab=xtab;
		 repaint();
	 }
	 // -----------
	 public void updateEventList() {
		 updateJtree(eventlist);
	 }
	 //--------------
	 public void updateDraw(EventType ev, int eventnumber){
		 Enumeration e = draw.elements();
		 Forma tmp;
		 currentevent=new EventType(ev.getNumber(),ev.getName(),ev.getColor());
		 
		 if (CurrentObject!=null){
			 CurrentObject.setEvent(ev.getNumber(),ev.getName(),ev.getColor());
		 }
		 if (e.hasMoreElements()) {
			 e.nextElement(); // skip the skin name
			 e.nextElement();  // skip the image name
			 e.nextElement(); // skip the scroll object
		 }
		 while( e.hasMoreElements() ) {
			 tmp = (Forma)e.nextElement();
			 if (eventnumber==tmp.getValue() && tmp.selecionado)	{
				 tmp.setEvent(ev.getNumber(),ev.getName(),ev.getColor());
			 }
		 }
		 repaint();
	 }
	 //---
	 public void unSelect_All_Draw(){
		 CurrentObject=null;
		 Enumeration e = draw.elements()	;
		 Forma tmp;
		 if (e.hasMoreElements()) {
			 e.nextElement(); // skip the skin name
			 e.nextElement();  // skip the image name
			 e.nextElement(); // skip the scroll object
		 }
		 while( e.hasMoreElements() ){
			 tmp = (Forma) e.nextElement();
			 tmp.selecionado=false;
		 }
		 repaint();
	 }
	 //--- select the draw object that was clicked in tree
	 public void Select_Draw(String obj){
		 Enumeration e = draw.elements();
		 String xstr;
		 Forma tmp;
		 int event_without_draw=0;
		 unSelect_All_Draw();
		 JMenuHotSpot_Event.setEnabled(true);
		 JMenuItem_AddAll.setEnabled(true);
		 JMenuItem_DeleteAll.setEnabled(true);
		 if (CurrentObject!=null)
			 CurrentObject.selecionado=false;
		 if (e.hasMoreElements())
		 {
			 e.nextElement(); // skip the skin name
			 e.nextElement();  // skip the image name
			 e.nextElement(); // skip the scroll object
		 }
		 while( e.hasMoreElements() )  	{
			 tmp = (Forma)e.nextElement();
			 if (obj.equals("Glass Tool              ")) { // clicked on root. Select all
				 JMenuHotSpot_Event.setEnabled(false);
				 JMenuItem_AddAll.setEnabled(false);
				 JMenuItem_DeleteAll.setEnabled(false);
				 tmp.selecionado=true;
				 event_without_draw=1;
			 } else if (obj.equals(tmp.getObject())) { //if obj is one of drawlist
				 CurrentObject=tmp;
				 currentevent.setEventType(tmp.getValue(),tmp.getName(),tmp.getColor());
				 tmp.selecionado=true;
				 STATE = 1; // object was selected
				 repaint();
				 clickedonevent=false;
				 event_without_draw=1;
				 repaint();
				 return;
			 }
			 else if (obj.equals(tmp.name)){
				 JMenuHotSpot_Event.setEnabled(true);
				 JMenuItem_AddAll.setEnabled(true);
				 JMenuItem_DeleteAll.setEnabled(true);
				 currentevent.setEventType(tmp.getValue(),tmp.getName(),tmp.getColor());
				 tmp.selecionado=true;
				 clickedonevent=true; // clicked on a event
				 CurrentObject=null;
				 STATE=0;
				 event_without_draw=1;
			 }
		 }
		 if (event_without_draw==0){//one event without a draws was select
			 e = eventlist.elements();// so it is necessary do the verification on eventlist vector
			 EventType tmp2;
			 while( e.hasMoreElements() )   {
				 tmp2 = (EventType) e.nextElement();
				 if (obj.equals(tmp2.getName())) {
					 currentevent.setEventType(tmp2.getNumber(),tmp2.getName(),tmp2.getColor());
					 clickedonevent=true; // clicked on a event
					 CurrentObject=null;
					 STATE=0;
					 return;
				 }
			 }
		 }
		 repaint();
		 return;
	 }
	 // --
	 public void valueChanged(TreeSelectionEvent event) {
		 clickedontree=true;
		 clickedonevent=false;
		 if ((tree.getLastSelectedPathComponent())!=null) {		 
			 this.Select_Draw(tree.getLastSelectedPathComponent().toString());
		 }
	 }
	 // ----
	 public void Close_Project(){
		 JMenuItem_Save.setEnabled(false);
		 JMenuItem_Close.setEnabled(false);
		 Project_isOpen=false;
		 Imagename="";
		 imagem = toolkit.getImage(Imagename);		 
		 gdraw.clear();
		 draw.clear();
		 eventlist.clear();
		 skincont=0;
		 skinquant=0;
		 g1=null;
		 projectname.setName("");
		 setTitle("Interface Generator for PDA - Glass Tool");	 
		 updateEventList();
		 jTabbedPane.removeAll();
		 disablePanel();
		 repaint();
		 
		 
	 }
	 // --
	 public void disablePanel(){
		 jButton_Seleciona.setEnabled(false);
		 jButton_Rectangle.setEnabled(false);
		 jButton_Ellipse.setEnabled(false);
		 jButton_Image.setEnabled(false);
		 jButton_Generate.setEnabled(false);
		 jButton_Hide.setEnabled(false);
		 jPanel_tree.setEnabled(false);		 
		 tree.setEnabled(false);
		 jTabbedPane.setEnabled(false);
		 scrollPane.setEnabled(false);
		 jPanel_tree.setEnabled(false);
	 }
	 //--
	 public void enablePanel() {
		 jButton_Seleciona.setEnabled(true);
		 jButton_Rectangle.setEnabled(true);
		 jButton_Ellipse.setEnabled(true);
		 jButton_Image.setEnabled(true);
		 jButton_Generate.setEnabled(true);
		 jButton_Hide.setEnabled(true);
		 jPanel_tree.setEnabled(true);
		 tree.setEnabled(true);
		 scrollPane.setEnabled(true);
		 jPanel_tree.setEnabled(true);
		 jTabbedPane.setEnabled(true);
		 
		 
	 }
	 // --------
	 public void actionPerformed( ActionEvent event ){
		 int returnVal,opt;
		 Object source = event.getSource();
		 if ( source == jButton_exit) {
			 opt = JOptionPane.showConfirmDialog(this,"Do you want exit ?","GLASS Tool",JOptionPane.YES_NO_OPTION);
			 if (opt==0){
				 this.dispose();
				 System.exit(0);
			 }
		 } else if (source == JMenuItem_Skin){
			 skinquant++;
			 Vector xx = new Vector();
			 skincont++;
			 xx.add("Skin "+skincont);
			 xx.add("");
			 xx.add(addtab("Skin "+skincont));
			 gdraw.add(xx);
		 } else if (source == JMenuItem_Delete){
			 if (clickedontree && clickedonevent)  {
				 opt = JOptionPane.showConfirmDialog(this,"Do you want delete this event and the objects ?","GLASS Tool",JOptionPane.YES_NO_OPTION);
				 if (opt==0){
					 CurrentObject=null;
					 Enumeration e = draw.elements()	;
					 Forma tmp;
					 if (e.hasMoreElements())
					 {
						 e.nextElement(); // skip the skin name
						 e.nextElement();  // skip the image name
						 e.nextElement(); // skip the scroll object
					 }
					 while( e.hasMoreElements() ){
						 tmp = (Forma) e.nextElement();
						 if (tmp.selecionado){
							 e = draw.elements()	;
							 draw.remove(tmp);
						 }
					 }
					 STATE=0;
					 this.updateEventList();
					 repaint();
				 }
			 } else if (CurrentObject!=null){
				 opt = JOptionPane.showConfirmDialog(this,"Do you want delete this object ?","GLASS Tool",JOptionPane.YES_NO_OPTION);
				 if (opt==0){
					 draw.remove((Forma)CurrentObject);
					 this.updateEventList();
					 repaint();
				 }
			 }
		 }
		 else if (source==JMenuItem_AddAll)
		 {
			 opt = JOptionPane.showConfirmDialog(this,"Do you want add this object on all skins ?","GLASS Tool",JOptionPane.YES_NO_OPTION);
			 if (opt==0){
				 int i=0;
				 while (i<gdraw.size())
				 {
					 if (!(((Vector)gdraw.get(i)).get(0)).equals(skinnameselected))
						 ((Vector)gdraw.get(i)).add((Forma)CurrentObject.clone());
					 i++;
				 }
			 }
		 } else if (source==JMenuItem_DeleteAll) {
			 opt = JOptionPane.showConfirmDialog(this,"Do you want delete this object on all skins ?","GLASS Tool",JOptionPane.YES_NO_OPTION);
			 if (opt==0){
				 int i=0,x;
				 while (i<gdraw.size())	 {
					 Vector xvec = (Vector)gdraw.get(i);
					 x =3;
					 Forma tmp ;
					 while (x <xvec.size())	 {
						 tmp = (Forma)xvec.get(x);
						 if ((tmp.Description()).equals(CurrentObject.Description()))  {
							 ((Vector)gdraw.get(i)).removeElementAt(x);
						 }
						 x++;
					 }
					 i++;
				 }
			 }
		 } else if (source==JMenuItem_DeleteSkin){
			 opt = JOptionPane.showConfirmDialog(this,"Do you want delete this skins ?","GLASS Tool",JOptionPane.YES_NO_OPTION);
			 if (opt==0){
				 gdraw.remove(jTabbedPane.getSelectedIndex());
				 jTabbedPane.remove(jTabbedPane.getSelectedIndex());
				 g1=null;
				 int i=0,x;
				 while (i<gdraw.size())
				 {
					 Vector xvec = (Vector)gdraw.get(i);
					 x =3;
					 Forma tmp ;
					 while (x <xvec.size())  {
						 tmp = (Forma)xvec.get(x);
						 if (tmp.eventtab.equals(skinnameselected)) {
							 tmp.eventtab="";
							 tmp.eventtype=0;
						 }
						 x++;
					 }
					 i++;
				 }
				 skinquant--;
				 Resize_App();
			 }
		 }else if (source==EventValue){			 
			 glassevent.setEventList(eventlist);
			 glassevent.show_event(currentevent);
		 }else if (source==JMenuHotSpot_Event){		
			 glasshotspot.setEventList(eventlist);
			 glasshotspot.show_event(currentevent);			 
		 }else if (source==simpleType){
			 if (CurrentObject!=null){
				 CurrentObject.eventtype=0;
			 }
		 }else if (source==exitType){
			 if (CurrentObject!=null){
				 CurrentObject.eventtype=1;  		  		;
			 }
		 }else if (source==skinType){
			 if (CurrentObject!=null){
				 CurrentObject.eventtype=2;
				 glasstab.show_event(skinquant,CurrentObject.eventtab);
			 }
		 }else if (source==positionType){
			 if (CurrentObject!=null){
				 CurrentObject.eventtype=3;
			 }
		 }else  if (source==JMenuItem_Open)    {
			 if (Project_isOpen)	{// if there is a project opened
				 opt = JOptionPane.showConfirmDialog(this,"Do you want save your current project ?","GLASS Tool",JOptionPane.YES_NO_OPTION);
				 if (opt==0){
					 returnVal=Save_Project();
					 if (returnVal==0) {
						 Open_Project();
					 }
				 }
				 else {
					 Open_Project();
				 }
			 } else	 {
				 Open_Project();
			 }
		 }
		 else if (source==JMenuItem_Save){
			 returnVal=Save_Project();
		 } else if (source==JMenuItem_Close){
			 if (Project_isOpen)	{// if there is a project opened
				 opt = JOptionPane.showConfirmDialog(this,"Do you want save your current project ?","GLASS Tool",JOptionPane.YES_NO_OPTION);
				 if (opt==0){
					 returnVal=Save_Project();
					 if (returnVal==0)
						 {Close_Project();}
				 }
				 else
					 {Close_Project();}
			 }
			 else
				 {Close_Project();}
		 }
		 else if (source==JMenuItem_New) {
			 if (Project_isOpen)	{// if there is a project opened
				 opt = JOptionPane.showConfirmDialog(this,"Do you want save your current project ?","GLASS Tool",JOptionPane.YES_NO_OPTION);
				 if (opt==0){
					 returnVal=Save_Project();
					 if (returnVal==0) {
						 New_Project();
					 }
				 } else	 {
					 New_Project();	
				 }
			 } else	 {
				 New_Project();	
			 }
		 }
		 else if (source==JMenuItem_Environment){
			 environment.Show_Environment(WidthImageArea,HeightImageArea);
			 WidthImageArea=environment.getWidth();
			 HeightImageArea=environment.getHeight();
			 Resize_App();
		 }
		 else if (source==JMenuItem_SkinName)  	{
			 skinname.Show_SkinName();
		 }
		 else if (source==JMenuItem_About)  {
			 JOptionPane.showMessageDialog(this,   "   INTERFACE GENERATOR TOOL \n"+
			 "         libGLASS TOOL\n"+
			 "         Version  1.0\n"+
			 "Marcelo de Paiva Guimarães \n"+
			 "    Bruno Barberi Gnecco \n"+
			 " {paiva,brunobg}@lsi.usp.br \n","About - GLASS Tool",JOptionPane.INFORMATION_MESSAGE);
		 }
	 }
	 public void update_skinname()	 {
		 skinnameselected=skinname.getSkinName();
		 draw.set(0,skinnameselected);
	 }
	 // ------
	 public void Principal_menu() {
		 jMenuBar1 = new JMenuBar();
		 File = new JMenu();
		 File.setText("File");
		 File.setActionCommand("File");
		 jMenuBar1.add(File);
		 JMenuItem_New = new JMenuItem();
		 JMenuItem_New.setText("New");
		 JMenuItem_New.setActionCommand("New");
		 File.add(JMenuItem_New);
		 JMenuItem_New.addActionListener(this);
		 JMenuItem_Open = new JMenuItem();
		 JMenuItem_Open.setText("Open");
		 JMenuItem_Open.setActionCommand("Open");
		 File.add(JMenuItem_Open);
		 JMenuItem_Open.addActionListener(this);
		 JMenuItem_Save = new JMenuItem();
		 JMenuItem_Save.setText("Save");
		 JMenuItem_Save.setActionCommand("Save");
		 JMenuItem_Save.setEnabled(false);
		 File.add(JMenuItem_Save);
		 JMenuItem_Save.addActionListener(this);
		 JMenuItem_Close = new JMenuItem();
		 JMenuItem_Close.setText("Close");
		 JMenuItem_Close.setActionCommand("Close");
		 JMenuItem_Close.setEnabled(false);
		 File.add(JMenuItem_Close);
		 JMenuItem_Close.addActionListener(this);
		 Configure = new JMenu();
		 Configure.setText("Configure");
		 Configure.setActionCommand("Configure");
		 jMenuBar1.add(Configure);
		 JMenuItem_Environment = new JMenuItem();
		 JMenuItem_Environment.setText("Environment");
		 JMenuItem_Environment.setActionCommand("JMenuItem_Environment");
		 JMenuItem_Environment.addActionListener(this);
		 Configure.add(JMenuItem_Environment);
		 Glass = new JMenu();
		 Glass.setText("Glass");
		 Glass.setActionCommand("Glass");
		 jMenuBar1.add(Glass);
		 JMenuItem_About = new JMenuItem();
		 JMenuItem_About.setText("About");
		 JMenuItem_About.setActionCommand("About");
		 JMenuItem_About.addActionListener(this);
		 Glass.add(JMenuItem_About);
		 setJMenuBar(jMenuBar1);
	 }
	 // ---
	 public void updateEventList(Vector ev) {
		 eventlist=ev;
		 updateJtree(eventlist);
	 }
	 // --
	 public void updateJtree(Vector ev)  {
		 Enumeration e = ev.elements(),d;
		 EventType tmp;
		 Forma tmp2;
		 root.removeAllChildren();
		 tree.setCellRenderer(new Tree_Renderer());
		 while( e.hasMoreElements() )  	{
			 tmp = (EventType) e.nextElement();
			 itemEvent = new DefaultMutableTreeNode((Object)tmp.getName());
			 d=draw.elements();
			 if (d.hasMoreElements()) {
				 d.nextElement(); // skip the skin name
				 d.nextElement();  // skip the image name
				 d.nextElement(); // skip the scroll object
			 }
			 while (d.hasMoreElements())	{
				 tmp2 = (Forma)d.nextElement();
				 if (tmp.getNumber()==tmp2.getValue())  {
					 itemEvent.add(new DefaultMutableTreeNode((Object)tmp2.getDescription()));
				 }
			 }
			 // the node is added just if has children
			 if (itemEvent.getChildCount()>0){
				 root.add(itemEvent);
			 }
		 }
		 treeModel.reload(root);
	 }
	 // ----
	 public EventType getEventType(String xname) {
		 Enumeration e = eventlist.elements();
		 EventType tmp;
		 while( e.hasMoreElements() )  	{
			 tmp = (EventType) e.nextElement();
			 if (xname.equals(tmp.getName())) {
				 return tmp;
			 }
		 }
		 return null ;
	 }
	 // --
	 void Save_file(String filename){
		 Enumeration e = draw.elements();
		 Forma tmp;
		 try	{
			 FileOutputStream file = new FileOutputStream(filename+".glass");
			 String ponto=";",xx="";
			 file.write((String.valueOf(WidthImageArea)).getBytes());
			 file.write(ponto.getBytes());
			 file.write((String.valueOf(HeightImageArea)).getBytes());
			 file.write(ponto.getBytes());
			 int i=0,x;
			 while (i<gdraw.size())	 {
				 Vector xvec = (Vector)gdraw.get(i);
				 xx = (String)xvec.get(1); // image
				 
				 file.write(xx.getBytes());
				 file.write(ponto.getBytes());
				 x =3;
				 while (x <xvec.size())	 {
					 tmp = (Forma)xvec.get(x);
					 xx =tmp.Description();
					 file.write(xx.getBytes());
					 file.write(ponto.getBytes());
					 x++;
				 }
				 xx="skin";
				 file.write(xx.getBytes() );
				 file.write(ponto.getBytes());
				 xx = this.jTabbedPane.getTitleAt(i); //skin
				 file.write(xx.getBytes());
				 file.write(ponto.getBytes());
				 i++;
			 }
			 file.close();
		 }
		 catch (IOException ex)	 {
			 System.out.println("Erro:" + ex.toString());  	
		 }
	 }
	 // ---
	 JScrollPane addtab(String name) {
		 JScrollPane jScrollPane1 = new JScrollPane();
		 jScrollPane1.addMouseListener(aSymMouse);
		 jScrollPane1.addMouseMotionListener(aSymMouseMotion);
		 jScrollPane1.addMouseListener(popupListener);
		 jScrollPane1.setDoubleBuffered(true);
		 jTabbedPane.addTab(name,jScrollPane1);
		 Resize_App();
		 return 	jScrollPane1;
	 }
	 // --
	 void Read_file(String filename){
		 int state=0,input;
		 String xstr="",xwidth="",xheight="",type="",x="",y="",m="",n="",rcor="",gcor="",bcor="";
		 String name="",val="",exi="",xtab="",xski="";
		 gdraw.clear();
		 draw.clear();
		 eventlist.clear();
		 jTabbedPane.removeAll();
		 skinquant=0;
		 objquant=0;
		 try	{
			 FileInputStream file = new FileInputStream(filename);
			 while (true)  {
				 input = file.read();
				 if (input == -1) {
					 break;
				 }
				 if (xstr.equals("skin")) {
					 state=20;
					 xstr="";
				 }else if(state==0 && (char)input == ';')  	{
					 WidthImageArea=Integer.valueOf(xstr).intValue();
					 xstr="";
					 state=1;
				 }else if(state==1 && (char)input == ';')   	{
					 HeightImageArea=Integer.valueOf(xstr).intValue();
					 Resize_App();
					 xstr="";
					 state=2;
				 }else if (state==2 && (char)input == ';'){
					 draw.clear();
					 Imagename=xstr;
					 imagem = toolkit.getImage(xstr);
					 objquant++;
					 draw.add(""); // skin name
					 draw.add(Imagename); // image name
					 draw.add(""); // scroll object
					 xstr="";
					 state=3;
				 }else if(state==3 && (char)input == ';')   	{
					 type=xstr;
					 xstr="";
					 state=4;
				 }else if(state==4 && (char)input == ';')   	{
					 x=xstr;
					 xstr="";
					 state=5;
				 }else if(state==5 && (char)input == ';')	{
					 y=xstr;
					 xstr="";
					 state=6;
				 }else if(state==6 && (char)input == ';')  	{
					 m=xstr;
					 xstr="";
					 state=7;
				 }else if(state==7 && (char)input == ';')  	{
					 n=xstr;
					 xstr="";
					 state=8;
				 }else if(state==8 && (char)input == ';')  	{
					 val=xstr;
					 xstr="";
					 state=9;
				 }else if(state==9 && (char)input == '=') {
					 state=10;
				 }else if(state==10 && (char)input == ',') 	{
					 rcor=xstr;
					 xstr="";
					 state=11;
				 }else if(state==11 && (char)input == '=')  	{
					 state=12;
					 xstr="";
				 }else if(state==12 && (char)input == ',')  	{
					 gcor=xstr;
					 xstr="";
					 state=13;
				 }else if(state==13 && (char)input == '=')  	{
					 xstr="";
					 state=14;
				 }else if(state==14 && (char)input == ']')  	{
					 bcor=xstr;
					 xstr="";
					 state=15;
				 }else if(state==15 && (char)input == ';') {
					 state=16;
				 }else if(state==16 && (char)input == ';') {
					 name=xstr;
					 xstr="";
					 state=17;
				 }else if(state==17 && (char)input == ';') {
					 exi=xstr;
					 xstr="";
					 state=18;
				 }else if(state==18 && (char)input == ';'){
					 xtab=xstr;
					 xstr="";
					 state=19;
				 }else if(state==19 && (char)input == ';')  	{
					 objquant=objquant+1;
					 if (!type.equals(""))
						 Add_Event(Integer.valueOf(val).intValue(),name,new Color(Integer.valueOf(rcor).intValue(),Integer.valueOf(gcor).intValue(),Integer.valueOf(bcor).intValue()));
					 if (type.equals("Rectangle"))
						 draw.add(new Rectangle(Integer.valueOf(x).intValue(),Integer.valueOf(y).intValue(),Integer.valueOf(m).intValue(), Integer.valueOf(n).intValue(),Integer.valueOf(val).intValue(),new Color(Integer.valueOf(rcor).intValue(),Integer.valueOf(gcor).intValue(),Integer.valueOf(bcor).intValue()),name,Integer.valueOf(exi).intValue(),xtab));
					 else if (type.equals("Ellipse"))
						 draw.add(new Ellipse(Integer.valueOf(x).intValue(),Integer.valueOf(y).intValue(),Integer.valueOf(m).intValue(), Integer.valueOf(n).intValue(),Integer.valueOf(val).intValue(),new Color(Integer.valueOf(rcor).intValue(),Integer.valueOf(gcor).intValue(),Integer.valueOf(bcor).intValue()),name,Integer.valueOf(exi).intValue(),xtab));
					 type=xstr;
					 xstr="";
					 state=4;
				 }else if(state==20 && (char)input == ';')  	{
					 xski=xstr;
					 xstr="";
					 objquant=objquant+1;
					 if (!type.equals(""))
						 Add_Event(Integer.valueOf(val).intValue(),name,new Color(Integer.valueOf(rcor).intValue(),Integer.valueOf(gcor).intValue(),Integer.valueOf(bcor).intValue()));
					 if (type.equals("Rectangle"))
						 draw.add(new Rectangle(Integer.valueOf(x).intValue(),Integer.valueOf(y).intValue(),Integer.valueOf(m).intValue(), Integer.valueOf(n).intValue(),Integer.valueOf(val).intValue(),new Color(Integer.valueOf(rcor).intValue(),Integer.valueOf(gcor).intValue(),Integer.valueOf(bcor).intValue()),name,Integer.valueOf(exi).intValue(),xtab));
					 else if (type.equals("Ellipse"))
						 draw.add(new Ellipse(Integer.valueOf(x).intValue(),Integer.valueOf(y).intValue(),Integer.valueOf(m).intValue(), Integer.valueOf(n).intValue(),Integer.valueOf(val).intValue(),new Color(Integer.valueOf(rcor).intValue(),Integer.valueOf(gcor).intValue(),Integer.valueOf(bcor).intValue()),name,Integer.valueOf(exi).intValue(),xtab));
					 draw.set(0,xski); // skin name
					 draw.set(2,addtab(xski)); // scroll object
					 gdraw.add(draw.clone());
					 skinquant++;
					 state=2;
					 objquant=0;
				 }else if ((char)input != ';' && state!= 9 && state!= 11 && state!= 13 && state!= 15 && state!= 21 )  {
					 xstr=xstr+(char)input;
				 }
			 }
			 file.close();
		 }catch (IOException ex) {
			 System.out.println("Erro" + ex .toString()); 
		 }
		 if (currentevent==null)
			 {Add_Event(1,"Button 1",new Color(10,20,102));	}
		 updateEventList();
		 draw = (Vector)gdraw.firstElement();
		 skinnameselected = (String)draw.get(0);
		 imagem = toolkit.getImage((String)draw.get(1));
		 jScrollPane1 =(JScrollPane)draw.get(2);
		 jTabbedPane.setSelectedIndex(0);
		 g1 = jScrollPane1.getGraphics();
		 repaint();
	 }
	 // ---
	 public void Add_Event(int xnum, String xname, Color xcolor){
		 Enumeration e = eventlist.elements();
		 EventType tmp;
		 while( e.hasMoreElements() )   {
			 tmp = (EventType) e.nextElement();
			 if (tmp.getNumber()==xnum) {
				 return;
			 }
		 }
		 currentevent = new EventType(xnum,xname,xcolor);
		 eventlist.add(currentevent);
	 }
	 // --
	 public void Resize_App() {
		 int xWidth=525,xHeight=450;
		 if (skinquant < 5)
			 jTabbedPane.setBounds(110,12,WidthImageArea,HeightImageArea+35);
		 else if (skinquant <9)
			 jTabbedPane.setBounds(110,12,WidthImageArea,HeightImageArea+60);
		 else if (skinquant <13)
			 jTabbedPane.setBounds(110,12,WidthImageArea,HeightImageArea+85);
		 else if (skinquant <17)
			 jTabbedPane.setBounds(110,12,WidthImageArea,HeightImageArea+110);
		 //------
		 if (jTabbedPane.getHeight()>350)
			 xHeight= jTabbedPane.getHeight()+100;
		 //------------
		 if (jTabbedPane.getWidth()>240)
			 xWidth=jTabbedPane.getWidth()+285;		
		 setSize(xWidth,xHeight);
		 jButton_exit.setBounds(xWidth-120,xHeight-115+30,99,31);
		 jPanel_tree.setBounds(xWidth-168,42,155,320);
		 JLabel_hotspot.setBounds(xWidth-160,2,170,50);
		 validate();
	 }
	 /*
	 * check if there is hot spots associated
	 * with the event
	 */
	 public boolean canDelete(int xevent){
		 Enumeration e = draw.elements();
		 Forma tmp;
		 if (e.hasMoreElements()){
			 e.nextElement(); // skip the skin name
			 e.nextElement();  // skip the image name
			 e.nextElement(); // skip the scroll object
		 }		 
		 while( e.hasMoreElements() ) 	{			 
			 tmp = (Forma) e.nextElement();			  
			 if (tmp.getValue()==xevent) {
				 return false;
			 }
		 }
		 return true;
	 }
	 // --
	 public void New_Project() {
		 if (projectname.New()==0){
			 JMenuItem_Save.setEnabled(true);
			 JMenuItem_Close.setEnabled(true);
			 Project_isOpen=true;
			 skinquant=1;
			 Imagename="";
			 enablePanel();
			 draw.clear();
			 gdraw.clear();
			 eventlist.clear();
			  jTabbedPane.removeAll();
			 skincont++;
			 draw.add("Skin "+skincont); // first element - skin name
			 draw.add(Imagename);        // second element - image name
			 currentevent= new EventType(1,"Button 1",new Color((int)(Math.random()*255),(int)(Math.random()*255),(int)(Math.random()*255)));
			 eventlist.add(currentevent);
			 glassevent.setEventList(eventlist);
			 setTitle("Interface Generator - libGlass Tool- "+projectname.getName()+".glass");
			 draw.add(addtab("Skin "+skincont));
			 g1 = ((JScrollPane)draw.get(2)).getGraphics();
			 gdraw.add(draw.clone());
			 draw =(Vector)gdraw.firstElement();
			 imagem = toolkit.getImage((String)draw.get(0));
			 jScrollPane1 = (JScrollPane)draw.get(2);
			 jTabbedPane.setSelectedIndex(0);
			 skinnameselected="Skin "+skincont;
			 updateEventList();
			 repaint();			 
		 }
	 }
	 // ---
	 public int Save_Project() {
		 //JFileChooser fc = new JFileChooser();
		 fc.setDialogTitle("Save a GLASS project");
		 //fc.setCurrentDirectory(new File("."));
		 fc.addChoosableFileFilter(new GlassFilter());
		 File f = new File(projectname.getName());
		 fc.setSelectedFile(f);
		 int	returnVal = fc.showSaveDialog(this);
		 if (returnVal == JFileChooser.APPROVE_OPTION) {
			 File file = fc.getSelectedFile();
			 int pos =(file.getAbsolutePath()).indexOf("libglass");
			// System.out.println("../../.."+(file.getAbsolutePath()).substring(pos+8));
			 //Save_file(file.getAbsolutePath());
			  Save_file("../../.."+(file.getAbsolutePath()).substring(pos+8));
		 } else {
			 JOptionPane.showMessageDialog(this, "Your project was not save!!","GLASS Tool",JOptionPane.ERROR_MESSAGE);
		 }
		 return returnVal;
	 }
	 // ----
	 public void Open_Project(){
		 fc.setDialogTitle("Open GLASS project");
		 fc.addChoosableFileFilter(new GlassFilter());
		 
		 int returnVal = fc.showOpenDialog(this);
		 if (returnVal == JFileChooser.APPROVE_OPTION){
			 JMenuItem_Save.setEnabled(true);
			 JMenuItem_Close.setEnabled(true);
			 File file = fc.getSelectedFile();
			 int x = (file.getName()).indexOf(".glass");
			 projectname.setName((file.getName()).substring(0,x));
			 Read_file(file.getAbsolutePath());
			 enablePanel();
			 Project_isOpen=true;
			 setTitle("Interface Generator for PDA - libGlass Tool- "+projectname.getName()+".glass");
			 updateEventList();
		 }
	 }
	 /****************************************************/
	 void jScrollPane1_mouseDragged(java.awt.event.MouseEvent event)	{
		 Enumeration e = draw.elements();
		 int x,y;
		 if (STATE==1)  {// object is selected		 
			 if (CurrentObject!=null && RESIZE_TYPE==0){
				 if (CurrentObject.selecionado)  {
					 x=oldX-event.getX();
					 if (CurrentObject.x1-x<0){	// draw on left side
						 CurrentObject.x2=CurrentObject.x2-CurrentObject.x1;
						 CurrentObject.x1=0;
					 } else if (CurrentObject.x2-x>240){ // draw on right side
						 CurrentObject.x1=240-(CurrentObject.x2-CurrentObject.x1);
						 CurrentObject.x2=240;
					 } else {	    // draw on the middle
						 CurrentObject.x1=CurrentObject.x1-x;
						 CurrentObject.x2=CurrentObject.x2-x;
					 }
					 oldX=event.getX();
					 y=oldY-event.getY();
					 if (CurrentObject.y1-y<0){ // draw upper side
						 CurrentObject.y2=CurrentObject.y2-CurrentObject.y1;
						 CurrentObject.y1=0;
					 }else if (CurrentObject.y2-y>320){ // draw down side
						 CurrentObject.y1=320-(CurrentObject.y2-CurrentObject.y1);
						 CurrentObject.y2=320;
					 }else{		 // draw on the middle
						 CurrentObject.y1=CurrentObject.y1-y;
						 CurrentObject.y2=CurrentObject.y2-y;
					 }
					 oldY=event.getY();
					 repaint();
				 }
			 } else if (RESIZE_TYPE	==1) {
				 CurrentObject.InitialPoint(event.getX(), event.getY());
			 } else if (RESIZE_TYPE==2){
				 CurrentObject.PontoFinal(event.getX(), event.getY());
			 } else if (RESIZE_TYPE==3) {
				 CurrentObject.Point(event.getX(),CurrentObject.y1,CurrentObject.x2,event.getY());
			 } else if (RESIZE_TYPE==4) {
				 CurrentObject.Point(CurrentObject.x1, event.getY(),event.getX(),CurrentObject.y2);
			 }
			 repaint();
			 this.updateEventList();
		 }
		 else if (jButton_Rectangle.isSelected() || jButton_Ellipse.isSelected()){
			 CurrentObject.PontoFinal(event.getX(), event.getY());
			 this.updateEventList();
			 repaint();
		 }
	 }
	 /**************************************************/
	 class Tree_Renderer extends DefaultTreeCellRenderer {
		 public Tree_Renderer() {
			 
		 }
		 
		 public Component getTreeCellRendererComponent(JTree tree, Object value,
		 boolean sel,   boolean expanded, boolean leaf,
		 int row, boolean hasFocus) {
			 Component c;
			 if (leaf==true) {
				 EventType xev = getEventType(value.toString());
				 if (xev!=null)	{
					 super.getTreeCellRendererComponent(tree, xev.getName(),sel,expanded, leaf, row,hasFocus);
					 this.setBackground(xev.getColor());
					 this.setForeground(xev.getColor())  ;
				 } else {
					 super.getTreeCellRendererComponent(tree, value,sel,expanded, leaf, row,hasFocus);
				 }
				 return this;
			 }
			 super.getTreeCellRendererComponent(tree, value,sel,expanded, leaf, row,hasFocus);
			 return this;
		 }
	 }
	 /****************************************/
	 class SymMouse2 extends java.awt.event.MouseAdapter		{
		 public void mousePressed(java.awt.event.MouseEvent event){
			 if ( Project_isOpen && !skinnameselected.equals(jTabbedPane.getTitleAt(jTabbedPane.getSelectedIndex()))){
				 int i=0;				 
				 String xx;
				 Vector xvec;
				 unSelect_All_Draw();				 
				 while (i<gdraw.size()){
					 xvec = (Vector)gdraw.get(i);
					 xx = (String)xvec.get(0); // skin name
					 if (xx.equals(jTabbedPane.getTitleAt(jTabbedPane.getSelectedIndex()))){
						 draw = (Vector)gdraw.get(i);
						 imagem = toolkit.getImage((String)draw.get(1));
						 jScrollPane1 = (JScrollPane)draw.get(2);
						 g1 = jScrollPane1.getGraphics();
						 skinnameselected=xx;
						 updateEventList();
						 repaint();
						 return;
					 }
					 i++;
				 }
				 updateEventList();
			 }
		 }
		 
		 
	 }	 	 
	 /***************************************/
	 class SymMouse extends java.awt.event.MouseAdapter		{
		 // image area is clicked
		 
		 public void mousePressed(java.awt.event.MouseEvent event)	{
			 if (clickedonevent)
				 {unSelect_All_Draw();}
			 clickedontree = false;
			 clickedonevent=false;
			 JMenuHotSpot_Event.setEnabled(true);
			 JMenuItem_AddAll.setEnabled(true);
			 JMenuItem_DeleteAll.setEnabled(true);
			 if (event.getSource() == jScrollPane1)	{
				 Enumeration e = draw.elements();
				 Forma tmp;				 
				 if (CurrentObject!=null && CurrentObject.selecionado){
					 currentevent.setEventType(CurrentObject.getValue(),CurrentObject.getName(),CurrentObject.getColor());
					 RESIZE_TYPE=CurrentObject.Resize(event.getX(), event.getY());
					 if 	(RESIZE_TYPE!=0){
						 STATE = 1;
						 
						 return;
					 }
				 }				 
				 if (jButton_Rectangle.isSelected())	{
					 if (CurrentObject!=null)
						 CurrentObject.selecionado=false;
					 CurrentObject = new Rectangle(event.getX(), event.getY(), event.getX()+1, event.getY()+1,currentevent.getNumber(),currentevent.getColor(),currentevent.getName(),0,"");
					 CurrentObject.selecionado=true;
					 draw.add((Forma)CurrentObject);
					 
				 } else if (jButton_Seleciona.isSelected()){
					 CurrentObject=null;
					 if (e.hasMoreElements()) {
						 e.nextElement(); // skip the skin name
						 e.nextElement();  // skip the image name
						 e.nextElement(); // skip the scroll object
					 }
					 while( e.hasMoreElements() ){
						 tmp = (Forma) e.nextElement();
						 tmp.selecionado=false;
						 if (tmp.Selecionado(event.getX(), event.getY())){							 
							 oldX=event.getX();
							 oldY=event.getY();
							 CurrentObject=tmp;
							 CurrentObject.selecionado=true;
							 currentevent.setEventType(CurrentObject.getValue(),CurrentObject.getName(),CurrentObject.getColor());
							 STATE = 1; // object was selected
						 }
					 }
					 repaint();
				 }
				 else if (jButton_Ellipse.isSelected())	{
					 if (CurrentObject!=null)
						 CurrentObject.selecionado=false;
					 CurrentObject = new Ellipse(event.getX(), event.getY(), event.getX()+1, event.getY()+1,currentevent.getNumber(),currentevent.getColor(),currentevent.getName(),0,"");
					 CurrentObject.selecionado=true;
					 draw.add((Forma)CurrentObject);
				 }
			 }
		 }
		 
		 public void mouseReleased(java.awt.event.MouseEvent event)	{
			 clickedontree = false;
			 Object object = event.getSource();
			 if (object == jScrollPane1)	{
				 STATE=0;
				 RESIZE_TYPE=0;
			 }
		 }
	 }
	 /**************************************************/
	 class SymAction implements java.awt.event.ActionListener, ItemListener
	 {
		 //JFileChooser fc = new JFileChooser();
		 
		 public void itemStateChanged(ItemEvent e)
		 {      }
		 
		 public void actionPerformed(java.awt.event.ActionEvent event){
			 Object source = event.getSource();
			 jButton_Seleciona.setSelected(false);
			 jButton_Rectangle.setSelected(false);
			 jButton_Ellipse.setSelected(false);
			 jButton_Generate.setSelected(false);
			 jButton_Image.setSelected(false);			 
			 if (source==jButton_Seleciona) {
				 jButton_Seleciona.setSelected(true);
				 if (CurrentObject!=null)
					 CurrentObject.selecionado=false;
			 }else if (source==jButton_Hide){
				 if (hide_image)
					 hide_image=false;
				 else
					 hide_image=true;
				 repaint();
			 }else if (source==jButton_Rectangle){
				 jButton_Rectangle.setSelected(true);
			 }else if (source==jButton_Ellipse) {
				 jButton_Ellipse.setSelected(true);
			 }else if (source==jButton_Generate)	 {
				 generate.Generate_App((Vector)eventlist.clone(),projectname.getName(),fc);
			 }else if (source==jButton_Image)	{
				 //JFileChooser fc = new JFileChooser();
				 fc.addChoosableFileFilter(new ImageFilter());
				 fc.setCurrentDirectory(new File(""));
				 jButton_Image.setSelected(true);
				 int returnVal = fc.showOpenDialog(editor);
				 if (returnVal == JFileChooser.APPROVE_OPTION) {
					 File file = fc.getSelectedFile();
					 //Imagename=file.getName();
					 //imagem = toolkit.getImage(Imagename);  // windows
					 
					 //Imagename =file.getAbsolutePath();
					 //imagem = toolkit.getImage(file.getAbsolutePath());
					 Imagename ="../../..";
					 // find "libglass" in the path
					 int pos =(file.getAbsolutePath()).indexOf("libglass");
					 // take the path starting from the libglass directory
					 String xx = file.getAbsolutePath().substring(pos+8); 
					 Imagename=Imagename + xx;					 			 
					 imagem = toolkit.getImage(Imagename);
					 
					 draw.set(1,Imagename);
				 }
			 }
		 }
	 }
	 /**************************************************/
	 
	 class SymMouseMotion extends java.awt.event.MouseMotionAdapter	  {
		 public void mouseDragged(java.awt.event.MouseEvent event)  {
			 clickedontree = false;
			 Object object = event.getSource();
			 if (object == jScrollPane1)
				 jScrollPane1_mouseDragged(event);
		 }
	 }
	 /****************************************/
	 class PopupListener extends MouseAdapter{
		 public void mousePressed(MouseEvent e)	 {
			 maybeShowPopup(e);  
		 }
		 
		 public void mouseReleased(MouseEvent e) {
			 maybeShowPopup(e);  
		 }
		 
		 private void maybeShowPopup(MouseEvent e)  	{
			 if (e.isPopupTrigger() && Project_isOpen){
				 
				 if ((CurrentObject!=null && clickedontree && clickedonevent) ||
				 CurrentObject==null ){
					 JMenuItem_Delete.setEnabled(false);
					 JMenuHotSpot_Event.setEnabled(false);
					 JMenuItem_AddAll.setEnabled(false);
					 JMenuItem_DeleteAll.setEnabled(false);
					 Type.setEnabled(false);
					 popup.show(e.getComponent(),e.getX(), e.getY());
				 } else {				 
					 JMenuItem_Delete.setEnabled(true);
					 JMenuHotSpot_Event.setEnabled(true);
					 JMenuItem_AddAll.setEnabled(true);
					 JMenuItem_DeleteAll.setEnabled(true);
					 Type.setEnabled(true);
					 if	(CurrentObject.eventtype==0)
						 simpleType.setSelected(true);
					 else if (CurrentObject.eventtype==1)
						 exitType.setSelected(true);
					 else if (CurrentObject.eventtype==2)
						 skinType.setSelected(true);
					 else
						 positionType.setSelected(true);
					 popup.show(e.getComponent(),e.getX(), e.getY());
				 }
				 
			 }
		 }
	 }
 }
 /******************************************/
