 /**
 *   GEditor - a interface generator for PDA Glass application
 * Marcelo de Paiva Guimaraes and Bruno Barberi Gnecco
 * Copyright (C) 2003,2004
 * 
 *  It is part of Glass - a distributed computing library
 *  
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License as published by the Free Software Foundation; either
 *  version 2 of the License, or (at your option) any later version.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 *  @author      Marcelo de Paiva Guimaraes
 *  @version     %I%, %G%
 *  @since       1.0
 */
 
 import java.awt.*;
 import java.awt.event.*;
 import javax.swing.*;
 import java.util.*;
 import java.io.*;

 

 
 public class Generate extends JFrame   {
	 protected int returnval=1;
	 protected String Imagename,projectname;
	 protected Vector draw=new Vector();
	 protected Enumeration e;
	 	 
	 public Generate(){
		
	 }
	 /*
	 *  Generate the C code
	 */
	 public void Generate_C_file(String xfilename){
		 String  text;	
		 int first=0,xrepeat=-1;    	
		 EventType tmp;
		 int x;
		 try {
			 FileOutputStream file = new FileOutputStream(xfilename);        
			 text="/* This is the event code to be included in your GLASS program*/ \n";            
			 file.write(text.getBytes());  
			 text ="enum event  {";
			 file.write(text.getBytes());   
			 Enumeration e = draw.elements();            
			 while( e.hasMoreElements() )  	{
				 tmp = (EventType) e.nextElement();
				 if (first==0){
					 text =tmp.getName()+"="+tmp.getNumber()+"\n";
					 first=1;
				 }else {
					 text="             ,"+tmp.getName()+"="+tmp.getNumber()+"\n";
				 }
				 file.write(text.getBytes());       
			 }               
			 text="};\n\n";            
			 file.write(text.getBytes());    
			 text="switch (event) { \n";
				 file.write(text.getBytes());    
				 e = draw.elements();
				 first=0;
				 while( e.hasMoreElements() ) {            	
					 tmp = (EventType) e.nextElement();
					 if (first==0){
						 text ="      case " +tmp.getNumber()+": //"+ tmp.getName()+" \n\n";
						 first=1;
					 }
					 else
						 {text ="      case " +tmp.getNumber()+": //"+ tmp.getName()+" \n\n";}
					 file.write(text.getBytes());       
					 text ="             break; \n";
					 file.write(text.getBytes());       
				 }          
			 text="}";
			 file.write(text.getBytes());       
			 file.close();
		 }
		 catch (IOException ex){
			 System.out.println("Error:" + ex.toString());
		 }	
	 }    
	 /* Generate_App
	 * Ask the destination file and generate the C code
	 */
	 public void Generate_App(Vector xdraw,String xprojectname,JFileChooser fc){		 	
		 draw=xdraw;			 
		 fc.setDialogTitle("Generate the C code");		 		 
		 File f = new File(xprojectname+".c");
		 fc.setSelectedFile(f);
		 int returnVal = fc.showSaveDialog(this);
		 if (returnVal == JFileChooser.APPROVE_OPTION) {
			 File file = fc.getSelectedFile();
			 Generate_C_file(file.getAbsolutePath());
			 JOptionPane.showMessageDialog(this, "The file C code was generated", "Code Generation",JOptionPane.INFORMATION_MESSAGE);
		 }
	 }		 	 
 }
 