 /**
 *   GEditor - a interface generator for PDA Glass application
 * Marcelo de Paiva Guimaraes and Bruno Barberi Gnecco
 * Copyright (C) 2003,2004
 * 
 *  It is part of Glass - a distributed computing library
 *  
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License as published by the Free Software Foundation; either
 *  version 2 of the License, or (at your option) any later version.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 *  @author      Marcelo de Paiva Guimaraes
 *  @version     %I%, %G%
 *  @since       1.0
 */
 import java.awt.*;
 import java.awt.event.*;
 import javax.swing.*;
 
 public class GlassEnvironment extends JDialog    implements ActionListener{
	 protected JLabel jLabel_ImageArea;
	 protected JButton JButton_ok,JButton_cancel;
	 protected JTextField JText_WidthImageArea,JText_HeightImageArea;
	 protected int oldWidth,oldHeight;
	 
	 public GlassEnvironment(JFrame pai) 	{
		 super( pai, "GLASS ENVIRONMENT", true);
		 //Center the window
		 Dimension screenSize = Toolkit.getDefaultToolkit().getScreenSize();
		 Dimension frameSize = this.getSize();
		 if (frameSize.height > screenSize.height) {
			 frameSize.height = screenSize.height;
		 }
		 if (frameSize.width > screenSize.width) {
			 frameSize.width = screenSize.width;
		 }
		 this.setLocation((screenSize.width - frameSize.width) / 2, (screenSize.height - frameSize.height) / 2);
		 
		 getContentPane().setLayout(null);
		 setVisible(false);
		 setSize(300,150);
		 jLabel_ImageArea = new JLabel();
		 jLabel_ImageArea.setBounds(10,5,300,55);
		 jLabel_ImageArea.setText("Image Area:   Width          Height");
		 getContentPane().add(jLabel_ImageArea);			
		 JText_WidthImageArea = new JTextField(20);
		 JText_WidthImageArea.setBounds(134,12,35,35);	
		 getContentPane().add(JText_WidthImageArea);		
		 JText_HeightImageArea = new JTextField(20);
		 JText_HeightImageArea.setBounds(214,12,35,35);	
		 getContentPane().add(JText_HeightImageArea);		
		 JButton_ok = new JButton();
		 JButton_ok.setText("OK");
		 JButton_ok.setBounds(30,76,112,32);
		 getContentPane().add(JButton_ok);
		 JButton_ok.addActionListener(this);    
		 JButton_cancel = new JButton();
		 JButton_cancel.setText("Cancel");
		 JButton_cancel.setBounds(170,76,112,32);
		 getContentPane().add(JButton_cancel);
		 JButton_cancel.addActionListener(this);
		 validate();
	 }
	 
	 public void Show_Environment(int xwidth,int xheight){
		 oldWidth=xwidth;
		 oldHeight=xheight;	
		 JText_WidthImageArea.setText(Integer.toString(xwidth));
		 JText_HeightImageArea.setText(Integer.toString(xheight));	
		 JText_WidthImageArea.requestFocus();
		 setVisible(true);
	 }	
	 
	 public int getWidth(){
		 return (new Integer(JText_WidthImageArea.getText())).intValue() ;
	 }
	 
	 public int getHeight(){
		 return 	(new Integer(JText_HeightImageArea.getText())).intValue();
	 }
	 
	 
	 public void actionPerformed(ActionEvent event){
		 Object source = event.getSource();
		 if ( source == JButton_cancel  ){
			 JText_WidthImageArea.setText(Integer.toString(oldWidth));
			 JText_HeightImageArea.setText(Integer.toString(oldHeight));
		 }
		 this.dispose( );	
	 }
 }    