 /**
 *   GEditor - a interface generator for PDA Glass application
 * Marcelo de Paiva Guimaraes and Bruno Barberi Gnecco
 * Copyright (C) 2003,2004
 * 
 *  It is part of Glass - a distributed computing library
 *  
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License as published by the Free Software Foundation; either
 *  version 2 of the License, or (at your option) any later version.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 *  @author      Marcelo de Paiva Guimaraes
 *  @version     %I%, %G%
 *  @since       1.0
 */
 import java.awt.*;
 import java.awt.event.*;
 import javax.swing.*;
 import java.util.*;
 
 public class GlassEvent extends JFrame    implements FocusListener,ActionListener{
	 protected JLabel jLabel_EventValue,jLabel_EventName,jLabel_EventColor;
	 protected JButton JButton_ok,JButton_cancel,JButton_new,JButton_color,JButton_delete;
	 protected JTextField JText_EventValue,JText_EventName;
	 protected int oldvalue;
	 protected String oldname;
	 
	 protected Cores cor;
	 protected JComboBox JCombo_List;
	 private Vector ev;
	 protected int lastevent;
	 private EventType ce;
	 private Editor edt;
	 
	 public GlassEvent(Editor ed){ 	
		 setTitle("Events");	
		 edt=ed;
		 cor= new Cores();
		 Dimension screenSize = Toolkit.getDefaultToolkit().getScreenSize();
		 Dimension frameSize = this.getSize();
		 if (frameSize.height > screenSize.height) {
			 frameSize.height = screenSize.height;
		 }
		 if (frameSize.width > screenSize.width) {
			 frameSize.width = screenSize.width;
		 }
		 this.setLocation((screenSize.width - frameSize.width) / 2, (screenSize.height - frameSize.height) / 2);
		 
		 JCombo_List = new JComboBox();
		 JCombo_List.setBounds(94,10,115,30);
		 JCombo_List.addActionListener(this);
		 getContentPane().add(JCombo_List, BorderLayout.NORTH);
		 getContentPane().setLayout(null);
		 setVisible(false);
		 setSize(330,200);
		 jLabel_EventValue = new JLabel();
		 jLabel_EventValue.setBounds(20,10,100,35);
		 jLabel_EventValue.setText("Event Value");
		 getContentPane().add(jLabel_EventValue);		
		 JText_EventValue = new JTextField(20);
		 JText_EventValue.setBounds(94,10,115,30);	
		 jLabel_EventName = new JLabel();
		 jLabel_EventName.setBounds(20,48,100,35);
		 jLabel_EventName.setText("      Name ");
		 getContentPane().add(jLabel_EventName);
		 jLabel_EventColor = new JLabel();
		 jLabel_EventColor.setBounds(20,86,100,35);
		 jLabel_EventColor.setText("      Color");	
		 getContentPane().add(jLabel_EventColor);
		 JText_EventName = new JTextField(20);
		 JText_EventName.setBounds(94,48,115,30);	
		 getContentPane().add(JText_EventName);	
		 JText_EventName.addActionListener(this);			
		 JButton_color = new JButton();
		 JButton_color.setText(" Color");
		 JButton_color.setBounds(94,86,115,30);
		 getContentPane().add(JButton_color);
		 JButton_color.addActionListener(this); 	
		 JButton_color.addFocusListener(this);	
		 JButton_new = new JButton();
		 JButton_new.setText("New");
		 JButton_new.setBounds(0,124,65,32);
		 getContentPane().add(JButton_new);
		 JButton_new.addActionListener(this);        		    
		 JButton_delete = new JButton();
		 JButton_delete.setText("Delete");
		 JButton_delete.setBounds(70,124,78,32);
		 getContentPane().add(JButton_delete);
		 JButton_delete.addActionListener(this);    
		 JButton_ok = new JButton();
		 JButton_ok.setText("OK");
		 JButton_ok.setBounds(153,124,63,32);
		 getContentPane().add(JButton_ok);
		 JButton_ok.addActionListener(this);            
		 JButton_cancel = new JButton();
		 JButton_cancel.setText("Cancel");
		 JButton_cancel.setBounds(223,124,78,32);
		 getContentPane().add(JButton_cancel);
		 JButton_cancel.addActionListener(this);	
		 validate();    
	 }
	 
	 public void setEventList(Vector xev){
		 ev=xev;
	 }
	 
	 public EventType getCurrentEvent(){
		 return ce;
	 }	
	 
	 public void show_event(EventType xce){		
		 ce=xce;
		 oldvalue=ce.getNumber();        
		 JCombo_List.removeAllItems();	
		 Enumeration e = ev.elements();	
		 EventType tmp;	
		 int x = ce.getNumber();
		 int cont=0,pos=0;
		 while( e.hasMoreElements() ) { 
			 cont++;
			 tmp = (EventType) e.nextElement();		  	      	
			 if (tmp.getNumber()==x) {
				 JText_EventName.setText(ce.getName());	
				 JButton_color.setBackground(ce.getColor());
				 pos=cont;	      			      		
			 }	      	  
			 JCombo_List.addItem((Object)String.valueOf(tmp.getNumber())+" - "+tmp.getName() );  	         	
			 lastevent=tmp.getNumber();     
		 }     	     
		 JCombo_List.setSelectedIndex(pos-1);
		 //JCombo_List.setSelectedIndex(x-1);     
		 edt.updateEventList(ev);
		 setVisible(true);       
		 
	 }
	 
	 public void focusGained(FocusEvent e) {
		 JButton_color.setBackground(cor.Obter_cor());	
	 }
	 
	 public void focusLost(FocusEvent e) {
		 // displayMessage("Focus lost", e);
	 }
	 
	 public void actionPerformed(ActionEvent event)
	 {	
		 
		 Object source = event.getSource();
		 if (source==JButton_color){
			 cor.show();
		 } else if (source==JButton_delete){
			 if (!edt.canDelete(ce.getNumber())){
				 JOptionPane.showMessageDialog(this, "There are button associated with this event. It can not be deleted !!","GLASS Tool",JOptionPane.ERROR_MESSAGE);
			 }else {	
				 Enumeration e = (ev).elements();
				 EventType tmp;
				 while( e.hasMoreElements() ) {
					 tmp = (EventType) e.nextElement();	      	
					 if (tmp.getNumber()==ce.getNumber()){
						 ev.remove(tmp);
					 }
				 }    			      					
				 edt.updateEventList(ev);
				 JCombo_List.removeItemAt(JCombo_List.getSelectedIndex());		
			 }
		 } else if ( source == JButton_cancel){
			 JText_EventValue.setText(Integer.toString(oldvalue));
			 JText_EventName.setText(oldname);		
			 setVisible(false);	
		 } else if ( source == JButton_new  ) {    	
			 lastevent=lastevent+1;
			 String xeventname ="Button"+lastevent;
			 JText_EventName.setText(xeventname);	
			 JCombo_List.addItem((Object)String.valueOf(lastevent)+" - "+xeventname);
			 JCombo_List.setSelectedIndex(lastevent-1);
			 Color xcolor = NewColor();
			 JButton_color.setBackground(xcolor);	     	    	     	      
			 ce	 = new EventType(lastevent,xeventname,xcolor);      	
			 ev.addElement(ce);
			 edt.updateEventList(ev);
		 } else if ( source == JButton_ok  ) {
			 ce.setName(JText_EventName.getText());	
			 ce.setColor(JButton_color.getBackground());
			 Enumeration e = (ev).elements();
			 EventType tmp;
			 while( e.hasMoreElements() ) {
				 tmp = (EventType) e.nextElement();	      	
				 if (tmp.getNumber()==ce.getNumber()) {
					 ev.set(ev.indexOf(tmp),ce);
				 }
			 } 
			 
			 edt.updateDraw(ce,oldvalue);  	
			 edt.updateEventList();     	
			 setVisible(false);       
		 } else if (source==JCombo_List) {         
			 String x=(String)JCombo_List.getSelectedItem();
			 if (x!=null) {
				 int xevent=Integer.parseInt(x.substring(0,x.indexOf("-")-1));
				 Enumeration e = ev.elements();
				 EventType tmp;
				 while( e.hasMoreElements() ) {
					 tmp = (EventType) e.nextElement();	
					 if (tmp.getNumber()==xevent) {
						 JText_EventName.setText(tmp.getName());	
						 JButton_color.setBackground(tmp.getColor());	
						 ce= new EventType(tmp.getNumber(),tmp.getName(),tmp.getColor());
					 }
				 }
			 } 
		 }		
		 else{
			 //this.dispose();
		 }
	 }        
	 
	 public Color NewColor() {
		 int m_Red=(int)(Math.random()*255);
		 int m_Green=(int)(Math.random()*255);
		 int m_Blue=(int)(Math.random()*255);
		 Color xcolor = new Color(m_Red,m_Green,m_Blue);	
		 Enumeration e = (ev).elements();
		 EventType tmp;
		 while( e.hasMoreElements() ){
			 tmp = (EventType) e.nextElement();	      	
			 if (tmp.getColor()==xcolor) {
				 e = (ev).elements();	
				 m_Red=(int)(Math.random()*255);
				 m_Green=(int)(Math.random()*255);
				 m_Blue=(int)(Math.random()*255);
				 xcolor = new Color(m_Red,m_Green,m_Blue);	    	
			 }
		 }    
		 return xcolor;	
	 }
 }      