 /**
 *   GEditor - a interface generator for PDA Glass application
 * Marcelo de Paiva Guimaraes and Bruno Barberi Gnecco
 * Copyright (C) 2003,2004
 * 
 *  It is part of Glass - a distributed computing library
 *  
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License as published by the Free Software Foundation; either
 *  version 2 of the License, or (at your option) any later version.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 *  @author      Marcelo de Paiva Guimaraes
 *  @version     %I%, %G%
 *  @since       1.0
 */
 import java.awt.*;
 import java.awt.event.*;
 import javax.swing.*;
 import java.util.*;
 
 public class GlassHotspot extends JFrame implements FocusListener,ActionListener{
	 protected JLabel jLabel_EventValue,jLabel_EventName;
	 protected JButton JButton_ok,JButton_cancel,JButton_color;
	 protected JTextField JText_EventValue,JText_EventName;
	 protected int oldvalue;	 	 
	 protected Cores cor;
	 protected JComboBox JCombo_List;
	 private Vector ev;
	 protected int lastevent;
	 private EventType ce;
	 private Editor edt;
	 
	 public GlassHotspot(Editor ed){ 	
		 setTitle("Hot Spot Association");	
		 edt=ed;
		 cor= new Cores();
		 Dimension screenSize = Toolkit.getDefaultToolkit().getScreenSize();
		 Dimension frameSize = this.getSize();
		 if (frameSize.height > screenSize.height) {
			 frameSize.height = screenSize.height;
		 }
		 if (frameSize.width > screenSize.width) {
			 frameSize.width = screenSize.width;
		 }
		 this.setLocation((screenSize.width - frameSize.width) / 2, (screenSize.height - frameSize.height) / 2);		 
		 JCombo_List = new JComboBox();
		 JCombo_List.setBounds(94,10,115,30);
		 JCombo_List.addActionListener(this);
		 getContentPane().add(JCombo_List, BorderLayout.NORTH);
		 getContentPane().setLayout(null);
		 setVisible(false);
		 setSize(260,200);
		 jLabel_EventValue = new JLabel();
		 jLabel_EventValue.setBounds(20,10,100,35);
		 jLabel_EventValue.setText("   Event");
		 getContentPane().add(jLabel_EventValue);		
		 JText_EventValue = new JTextField(20);
		 JText_EventValue.setBounds(94,10,115,30);	
		 jLabel_EventName = new JLabel();
		 jLabel_EventName.setBounds(20,48,100,35);
		 jLabel_EventName.setText("Associated");
		 getContentPane().add(jLabel_EventName);
		 JText_EventName = new JTextField(20);
		 JText_EventName.setBounds(94,48,115,30);
		 JText_EventName.setEnabled(false);
		 getContentPane().add(JText_EventName);	
		 JText_EventName.addActionListener(this);			
		 JButton_color = new JButton();
		 JButton_color.setText(" Color");
		 JButton_color.setBounds(94,86,115,30);
		 JButton_color.setEnabled(false);
		 getContentPane().add(JButton_color);
		 JButton_color.addActionListener(this); 	
		 JButton_color.addFocusListener(this);		 		     
		 JButton_ok = new JButton();
		 JButton_ok.setText("OK");
		 JButton_ok.setBounds(20,124,88,32);
		 getContentPane().add(JButton_ok);
		 JButton_ok.addActionListener(this);            
		 JButton_cancel = new JButton();
		 JButton_cancel.setText("Cancel");
		 JButton_cancel.setBounds(143,124,88,32);
		 getContentPane().add(JButton_cancel);
		 JButton_cancel.addActionListener(this);	
		 validate();    
	 }
	 
	 public void setEventList(Vector xev){
		 ev=xev;
	 }
	 
	 public EventType getCurrentEvent(){
		 return ce;
	 }	
	 
	/* shiw_event(EventType xce)
	This method is called by Editor, it sets
	the current event and creates the event list 
	*/
	 public void show_event(EventType xce){		
		 ce=xce;
		 oldvalue=ce.getNumber();        
		 JCombo_List.removeAllItems();	
		 Enumeration e = ev.elements();	
		 EventType tmp;	
		 int x = ce.getNumber();		 
		 int cont=0,pos=0;
		 while (e.hasMoreElements()){
			 cont++;
			 tmp = (EventType) e.nextElement();		  	      	
			 if (tmp.getNumber()==x){
				 JText_EventName.setText(ce.getName());	
				 JButton_color.setBackground(ce.getColor());
				 pos=cont;	      			      		
			 }	      	  
			 JCombo_List.addItem((Object)String.valueOf(tmp.getNumber())+" - "+tmp.getName() );  	         	
			 lastevent=tmp.getNumber();			 
		 }     	     
		 JCombo_List.setSelectedIndex(pos-1);		     
		 edt.updateEventList(ev);
		 setVisible(true);       		 
	 }	 
	 
	 public void focusGained(FocusEvent e) {
		 JButton_color.setBackground(cor.Obter_cor());	
	 }
	 
	 public void focusLost(FocusEvent e) {
		 // displayMessage("Focus lost", e);
	 }
	 
	 public void actionPerformed(ActionEvent event) {			 
		 Object source = event.getSource();
		 if (source==JButton_color){
			 cor.show();		 
		 }else if ( source == JButton_cancel){
			 JText_EventValue.setText(Integer.toString(oldvalue));			 		
			 setVisible(false);			 
		 }else if ( source == JButton_ok  ) {
			 ce.setName(JText_EventName.getText());	
			 ce.setColor(JButton_color.getBackground());
			 Enumeration e = (ev).elements();
			 EventType tmp;
			 while( e.hasMoreElements() ) {
				 tmp = (EventType) e.nextElement();	      	
				 if (tmp.getNumber()==ce.getNumber()) {
					 ev.set(ev.indexOf(tmp),ce);
				 }
			 } 			 
			 edt.updateDraw(ce,oldvalue);    	
			 edt.updateEventList();     	
			 setVisible(false);       
		 } else if (source==JCombo_List) {         
			 String x=(String)JCombo_List.getSelectedItem();
			 if (x!=null) {
				 int xevent=Integer.parseInt(x.substring(0,x.indexOf("-")-1));
				 Enumeration e = ev.elements();
				 EventType tmp;
				 while( e.hasMoreElements() ) {
					 tmp = (EventType) e.nextElement();	
					 if (tmp.getNumber()==xevent) {
						 JText_EventName.setText(tmp.getName());	
						 JButton_color.setBackground(tmp.getColor());	
						 ce= new EventType(tmp.getNumber(),tmp.getName(),tmp.getColor());
					 }
				 }
			 } 
		 }		
		 else{
			 //this.dispose();
		 }
	 }        	 
 }      