 /**
 *   GEditor - a interface generator for PDA Glass application
 * Marcelo de Paiva Guimaraes and Bruno Barberi Gnecco
 * Copyright (C) 2003,2004
 * 
 *  It is part of Glass - a distributed computing library
 *  
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License as published by the Free Software Foundation; either
 *  version 2 of the License, or (at your option) any later version.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 *  @author      Marcelo de Paiva Guimaraes
 *  @version     %I%, %G%
 *  @since       1.0
 */
 /* change the skin name */
 
 import java.awt.*;
 import java.awt.event.*;
 import javax.swing.*;
 
 public class GlassSkinName extends JDialog  implements ActionListener {
	 protected JLabel jLabel_Text;
	 protected JButton JButton_ok,JButton_cancel;
	 //protected 
	 JTextField JText_SkinName;
	 protected String oldName;
	 private Editor edt;
	 
	 public GlassSkinName(Editor ed) {
		 setTitle("Change the Skin Name");
		 edt=ed;
		 //Center the window
		 Dimension screenSize = Toolkit.getDefaultToolkit().getScreenSize();
		 Dimension frameSize = this.getSize();
		 if (frameSize.height > screenSize.height) {
			 frameSize.height = screenSize.height;
		 }
		 if (frameSize.width > screenSize.width) {
			 frameSize.width = screenSize.width;
		 }
		 this.setLocation((screenSize.width - frameSize.width) / 2, (screenSize.height - frameSize.height) / 2);
		 
		 getContentPane().setLayout(null);
		 setVisible(false);
		 setSize(300,150);
		 jLabel_Text = new JLabel();
		 jLabel_Text.setBounds(10,10,300,55);
		 jLabel_Text.setText("Skin Name");
		 getContentPane().add(jLabel_Text);			
		 JText_SkinName = new JTextField(20);
		 JText_SkinName.setBounds(105,12,135,35);	
		 getContentPane().add(JText_SkinName);		
		 JButton_ok = new JButton();
		 JButton_ok.setText("OK");
		 JButton_ok.setBounds(30,80,112,32);
		 getContentPane().add(JButton_ok);
		 JButton_ok.addActionListener(this);    
		 JButton_cancel = new JButton();
		 JButton_cancel.setText("Cancel");
		 JButton_cancel.setBounds(170,80,112,32);
		 getContentPane().add(JButton_cancel);
		 JButton_cancel.addActionListener(this);
		 validate();
	 }
	 
	 public void Show_SkinName() {
		 oldName=edt.jTabbedPane.getTitleAt(edt.jTabbedPane.getSelectedIndex());
		 JText_SkinName.setText(oldName);
		 JText_SkinName.requestFocus();
		 setVisible(true);
	 }	    
	 
	 public String getSkinName() {
		 return 	JText_SkinName.getText();
	 }	    		
	 
	 public void actionPerformed(ActionEvent event) {  	
		 Object source= event.getSource();
		 if (source ==JButton_ok){
			 edt.jTabbedPane.setTitleAt(edt.jTabbedPane.getSelectedIndex(),JText_SkinName.getText());	
			 edt.update_skinname();
		 }	
		 this.dispose( );	
	 }
 }    