 /**
 *   GEditor - a interface generator for PDA Glass application
 * Marcelo de Paiva Guimaraes and Bruno Barberi Gnecco
 * Copyright (C) 2003,2004
 * 
 *  It is part of Glass - a distributed computing library
 *  
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License as published by the Free Software Foundation; either
 *  version 2 of the License, or (at your option) any later version.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 *  @author      Marcelo de Paiva Guimaraes
 *  @version     %I%, %G%
 *  @since       1.0
 */
 
 import java.awt.*;
 import java.awt.event.*;
 import javax.swing.*;
 import java.util.*;
 
 public class GlassTab extends JFrame implements ActionListener{
	 protected JLabel jLabel_Tab;
	 protected JButton JButton_ok,JButton_cancel;
	 protected JComboBox JCombo_List;	
	 protected int eventquant=1;	
	 private Editor edt;
	 
	 public GlassTab(Editor ed) { 	
		 edt=ed;
		 setTitle("Event Association with a Tab - Glass Tool");
		 Dimension screenSize = Toolkit.getDefaultToolkit().getScreenSize();
		 Dimension frameSize = this.getSize();
		 if (frameSize.height > screenSize.height) {
			 frameSize.height = screenSize.height;
		 }
		 if (frameSize.width > screenSize.width) {
			 frameSize.width = screenSize.width;
		 }
		 this.setLocation((screenSize.width - frameSize.width) / 2, (screenSize.height - frameSize.height) / 2);
		 
		 
		 JCombo_List = new JComboBox();
		 JCombo_List.setBounds(110,10,115,30);
		 JCombo_List.addActionListener(this);    
		 getContentPane().add(JCombo_List, BorderLayout.NORTH);
		 getContentPane().setLayout(null);
		 setVisible(false);
		 setSize(300,150);
		 
		 jLabel_Tab = new JLabel();
		 jLabel_Tab.setBounds(16,10,100,35);
		 jLabel_Tab.setText("Choose a Tab :");	
		 getContentPane().add(jLabel_Tab);		
		 
		 JButton_ok = new JButton();
		 JButton_ok.setText("OK");
		 JButton_ok.setBounds(80,70,74,32);
		 getContentPane().add(JButton_ok);
		 JButton_ok.addActionListener(this);    
		 
		 JButton_cancel = new JButton();
		 JButton_cancel.setText("Cancel");
		 JButton_cancel.setBounds(187,70,84,32);
		 getContentPane().add(JButton_cancel);
		 JButton_cancel.addActionListener(this);
		 validate();    
	 }
	 
	 public void show_event(int xquant, String xtab){
		 eventquant = xquant;
		 JCombo_List.removeAllItems();	
		 int x = 0;		
		 while( x < eventquant ) {      	
			 x++;      	         	
			 JCombo_List.addItem(edt.jTabbedPane.getTitleAt(x-1));
			 if (xtab.equals(edt.jTabbedPane.getTitleAt(x-1)))
				 JCombo_List.setSelectedIndex(x-1);      	
		 }     	             
		 setVisible(true);       
	 }
	 
	 public void actionPerformed(ActionEvent event) {			 
		 Object source = event.getSource();
		 if (source==JButton_cancel) {  		
			 setVisible(false);	
		 }
		 else if ( source == JButton_ok  ) {     	    	
			 edt.updatedObjectTab((String)JCombo_List.getSelectedItem());
			 setVisible(false);       
		 }
	 }        
	 
 }      