 /**
 *   GEditor - a interface generator for PDA Glass application
 * Marcelo de Paiva Guimaraes and Bruno Barberi Gnecco
 * Copyright (C) 2003,2004
 * 
 *  It is part of Glass - a distributed computing library
 *  
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License as published by the Free Software Foundation; either
 *  version 2 of the License, or (at your option) any later version.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 *  @author      Marcelo de Paiva Guimaraes
 *  @version     %I%, %G%
 *  @since       1.0
 */
 import java.awt.*;
 import java.awt.event.*;
 import java.util.*;
 import java.io.*;
 
 class Gpda extends Frame{	   
	 private Image backGroundImage=null;
	 private Vector draw = new Vector(); // skins
	 private Vector gdraw = new Vector();  // vector of skins      
	 private int skinquant=0;  // skin quantity
	 static String host="localhost";
	 int WidthImageArea=0,HeightImageArea=0;
	 private Toolkit toolkit = Toolkit.getDefaultToolkit();
	 private String Imagename="",filename;
	 private Image imagem = toolkit.getImage(Imagename);        
	 Send s;
	 Thread s1;
	 
	 public void processMouseEvent(MouseEvent e)
	 {
		 int i=3;
		 Forma tmp=null;
		 if (e.getID() == MouseEvent.MOUSE_PRESSED) 
		 {
			 while ((i<draw.size()))		
			 {            
				 tmp = (Forma)draw.get(i);	
				 if (tmp.Selecionado(e.getX(), e.getY())) 
				 {	
					 //found=true;   		      
					 getToolkit().beep();                  	  
					 if (tmp.eventtype ==0) {// 0-simple   1-exit  2-change skin 3 -position      	  
						 s.setTrue(tmp.val);                	  
					 }else if (tmp.eventtype ==1) {
						 s.setTrue(tmp.val);            	  		  
						 this.dispose();
						 System.exit(0);					  
					 }else if (tmp.eventtype ==2) {      	      		  
						 changeSkin(tmp.eventtab);
					 }else{
						 s.setTrue(e.getX()+";"+e.getY());                  	  
					 }	  
				 }
				 i++;      
			 }      
		 }
		 else 
			 {s.setFalse();}	
	 }
	 
	 public void readSkin()
	 {			
		 int state=0,input;
		 String xstr="",xwidth="",xheight="",type="",x="",y="",m="",n="",rcor="",gcor="",bcor="";
		 String name="",val="",exi="",xtab="",xski="",xdefaultskin="";           
		 gdraw.clear();
		 draw.clear();	
		 skinquant=0;
		 
		 try	{    
			 FileInputStream file = new FileInputStream(filename);      		
			 while (true)  {
				 input = file.read();
				 if (input == -1)
				 {              
					 break;
				 }                   	
				 if (xstr.equals("skin")) {              
					 state=20;
					 xstr="";
				 }else if(state==0 && (char)input == ';')   	{
					 WidthImageArea=Integer.valueOf(xstr).intValue();
					 xstr="";	
					 state=1;
				 }else if(state==1 && (char)input == ';')   	{
					 HeightImageArea=Integer.valueOf(xstr).intValue();    
					 xstr="";	
					 state=2;          	  		          	  		          	  		          	  		
				 }else if (state==2 && (char)input == ';'){
					 draw.clear();
					 Imagename=xstr;	                		
					 imagem = toolkit.getImage(xstr);	
					 draw.add(" "); // skin name            	            	            	
					 draw.add(Imagename); // image name
					 draw.add(" "); // scroll object                     		            	            	
					 xstr="";
					 state=3;	          		
				 }else if(state==3 && (char)input == ';')   	{
					 type=xstr;
					 xstr="";
					 state=4;	
				 }else if(state==4 && (char)input == ';')   	{
					 x=xstr;
					 xstr="";
					 state=5;	
				 }else if(state==5 && (char)input == ';')	{
					 y=xstr;
					 xstr="";
					 state=6;	
				 }else if(state==6 && (char)input == ';')  	{
					 m=xstr;
					 xstr="";
					 state=7;	
				 }else if(state==7 && (char)input == ';')  	{
					 n=xstr;
					 xstr="";
					 state=8;	
				 }else if(state==8 && (char)input == ';')  	{
					 val=xstr;
					 xstr="";
					 state=9;	
				 }else if(state==9 && (char)input == '=')
				 {state=10;
				 }else if(state==10 && (char)input == ',') 	{                	
					 rcor=xstr;
					 xstr="";	
					 state=11;	                	
				 }else if(state==11 && (char)input == '=')  	{
					 state=12;	
					 xstr="";	
				 }else if(state==12 && (char)input == ',')  	{                
					 gcor=xstr;
					 xstr="";	
					 state=13;	
				 }else if(state==13 && (char)input == '=')  	{
					 xstr="";		
					 state=14;	
				 }else if(state==14 && (char)input == ']')  	{
					 bcor=xstr;
					 xstr="";	
					 state=15;
				 }else if(state==15 && (char)input == ';')
				 {state=16;
				 }else if(state==16 && (char)input == ';')  	{
					 name=xstr;
					 xstr="";	
					 state=17;              
				 }else if(state==17 && (char)input == ';') {             		
					 exi=xstr;
					 xstr="";	
					 state=18;              		
				 }else if(state==18 && (char)input == ';'){
					 xtab=xstr;
					 xstr="";
					 state=19;              		
				 }else if(state==19 && (char)input == ';')  	{            	
					 //	Add_Event(Integer.valueOf(val).intValue(),name,new Color(Integer.valueOf(rcor).intValue(),Integer.valueOf(gcor).intValue(),Integer.valueOf(bcor).intValue()));
					 if (type.equals("Rectangle"))
						 draw.add(new Rectangle(Integer.valueOf(x).intValue(),Integer.valueOf(y).intValue(),Integer.valueOf(m).intValue(), Integer.valueOf(n).intValue(),Integer.valueOf(val).intValue(),new Color(Integer.valueOf(rcor).intValue(),Integer.valueOf(gcor).intValue(),Integer.valueOf(bcor).intValue()),name,Integer.valueOf(exi).intValue(),xtab));
					 else
						 draw.add(new Ellipse(Integer.valueOf(x).intValue(),Integer.valueOf(y).intValue(),Integer.valueOf(m).intValue(), Integer.valueOf(n).intValue(),Integer.valueOf(val).intValue(),new Color(Integer.valueOf(rcor).intValue(),Integer.valueOf(gcor).intValue(),Integer.valueOf(bcor).intValue()),name,Integer.valueOf(exi).intValue(),xtab));				  	                              
					 type=xstr;
					 xstr="";	
					 state=4;	
				 }else if(state==20 && (char)input == ';')  	{            	
					 xski=xstr;           		
					 xstr="";	              		              			                                  		           		
					 //Add_Event(Integer.valueOf(val).intValue(),name,new Color(Integer.valueOf(rcor).intValue(),Integer.valueOf(gcor).intValue(),Integer.valueOf(bcor).intValue()));
					 if (type.equals("Rectangle"))
						 draw.add(new Rectangle(Integer.valueOf(x).intValue(),Integer.valueOf(y).intValue(),Integer.valueOf(m).intValue(), Integer.valueOf(n).intValue(),Integer.valueOf(val).intValue(),new Color(Integer.valueOf(rcor).intValue(),Integer.valueOf(gcor).intValue(),Integer.valueOf(bcor).intValue()),name,Integer.valueOf(exi).intValue(),xtab));
					 else
						 draw.add(new Ellipse(Integer.valueOf(x).intValue(),Integer.valueOf(y).intValue(),Integer.valueOf(m).intValue(), Integer.valueOf(n).intValue(),Integer.valueOf(val).intValue(),new Color(Integer.valueOf(rcor).intValue(),Integer.valueOf(gcor).intValue(),Integer.valueOf(bcor).intValue()),name,Integer.valueOf(exi).intValue(),xtab));				  	               					
					 draw.set(0,xski); // skin name
					 skinquant++;    	
					 gdraw.add(draw.clone());                    	    		              			
					 state=2;          	  	 	                				              				                			
				 }else if ((char)input != ';' && state!= 9 && state!= 11 && state!= 13 && state!= 15 && state!= 21 )  {
					 xstr=xstr+(char)input;
				 }
			 }
			 file.close();                     
		 }catch (IOException ex)
		 {System.out.println("Erro" + ex .toString()); }	        	
	 }		
	 
	 public Gpda(String xfilename,String xhost) {
		 host=xhost;
		 filename=xfilename;       
		 s=new Send(host);
		 s1= new Thread(s);
		 s1.start();
		 readSkin(); 
		 draw = (Vector)gdraw.get(0);	     	
		 changeSkin((String)draw.get(0));		        	        			
		 enableEvents( AWTEvent.MOUSE_EVENT_MASK |AWTEvent.MOUSE_MOTION_EVENT_MASK);
	 }
	 
	 public static void main(String args[]) {
		 if (args.length<2){
			 System.out.println("\n   Use: java -jar gpda.jar ProjectName.glass  host");
			 System.exit(0);
		 }
		 Gpda mainFrame = new Gpda(args[0],args[1]);	
		 mainFrame.setSize(240, 320);
		 mainFrame.setTitle("Glass Application");
		 mainFrame.setVisible(true);	
	 }
	 
	 public void paint(Graphics g)
	 {	
		 g.drawImage(backGroundImage, 0, 0, this);
	 }
	 
	 public void changeSkin(String xtab)
	 {
		 int i=0;
		 while (i<gdraw.size()) 
		 {
			 draw = (Vector)gdraw.get(i);
			 if (xtab.equals((String)draw.get(0)))
			 {
				 backGroundImage = toolkit.getImage((String)draw.get(1));
				 repaint();
				 return;
			 }
			 i++;
		 }	   
	 }
 }
