 /**
 *   GEditor - a interface generator for PDA Glass application
 * Marcelo de Paiva Guimaraes and Bruno Barberi Gnecco
 * Copyright (C) 2003,2004
 * 
 *  It is part of Glass - a distributed computing library
 *  
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License as published by the Free Software Foundation; either
 *  version 2 of the License, or (at your option) any later version.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 *  @author      Marcelo de Paiva Guimaraes
 *  @version     %I%, %G%
 *  @since       1.0
 */
 
 public class Send implements Runnable {
	 
	 boolean executei,executes;
	 int gpdaint;
	 String gpdastr;
	 String host;
	 
	 private native void clickevent(String xhost);
	 private native void destroyevent();
	 public  native void registerEvent(int number);
	 public  native void registerEvent(String position);
	 static  {System.loadLibrary("glasspda"); }
	 
	 
	 public Send(String xhost)
	 {
		 host=xhost;	
	 }
	 
	 public void run() // thread metod
	 {
		 this.clickevent(host);	
		 while (true){		
			 if (executei){
				 registerEvent(gpdaint);
				 executei=false; 
			 }else if (executes){
				 registerEvent(gpdastr);
				 executes=false; 
			 }
			 try {
				 Thread.sleep(40); //50
			 }catch (InterruptedException e){
				 // the VM doesn't want us to sleep anymore,
				 // so get back to work
			 }
		 }
	 }
	 public void setTrue(int xe){
		 gpdaint=xe;
		 executei=true;
	 }
	 
	 public void setTrue(String xe){
		 gpdastr=xe;
		 executes=true;
	 }
	 
	 public void setFalse(){
		 executei=false;
		 executes=false;
	 }
 }
