#include <jni.h>
#include "libglass.h"
#include "Send.h"
#include <iostream>
using namespace libglass;
using std::cerr;
using std::endl;

static GlassClient *gc = NULL;
static Event<int> *gpdaint; 
static Event<std::string> *gpdastr; 
/*
 * Class:     ClickEvent
 * Method:    clickevent
 * Signature: ()I
 */
JNIEXPORT void JNICALL Java_Send_clickevent
  (JNIEnv *env,jobject, jstring host){
        
	try {
	     if (!gc) {
                   jboolean isCopy;
                   const char* str=env->GetStringUTFChars(host,&isCopy);
                   //printf(str);
		   gc = new GlassClient(new TCP(),str); // server as argument
		   gpdaint  = new Event<int>("integer");
		   gpdastr  = new Event<std::string>("string");		   
                   }
	    }
	catch (Exception *e) 
            {	}
}

/*
 * Class:     ClickEvent
 * Method:    destroyevent
 * Signature: ()V
 */
JNIEXPORT void JNICALL Java_Send_destroyevent
  (JNIEnv *, jobject ) {
        delete gc;
}

/*
 * Class:     ClickEvent
 * Method:    registerEvent
 * Signature: (I)Z
 */

JNIEXPORT void JNICALL Java_Send_registerEvent__I
  (JNIEnv *, jobject, jint message){
	gpdaint->enqueueEvent(message);
}

/*
 * Class:     Send
 * Method:    registerEvent
 * Signature: (Ljava/lang/String;)V
 */
JNIEXPORT void JNICALL Java_Send_registerEvent__Ljava_lang_String_2
  (JNIEnv *env, jobject, jstring message){
	jboolean isCopy;
        const char* str=env->GetStringUTFChars(message,&isCopy);
	gpdastr->enqueueEvent(str);
}


