 /**
 *   GEditor - a interface generator for PDA Glass application
 * Marcelo de Paiva Guimaraes and Bruno Barberi Gnecco
 * Copyright (C) 2003,2004
 * 
 *  It is part of Glass - a distributed computing library
 *  
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License as published by the Free Software Foundation; either
 *  version 2 of the License, or (at your option) any later version.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 *  @author      Marcelo de Paiva Guimaraes
 *  @version     %I%, %G%
 *  @since       1.0
 */
 import java.awt.*;
 
 public abstract class Forma implements Cloneable  {	
	 protected int x1,y1,x2,y2,val;
	 protected String name,type;
	 protected Color cor;
	 protected boolean selecionado=false;	
	 protected int eventtype=0; //0 - click  1-exit  2-change skin  3- position
	 protected String eventtab=""; // the tab associated (if is eventtype=2)
	 
	 public Forma(int ax,int ay,int dx,int dy,int xvalue, Color xcolor,String xname,int xtype, String xtab)  {
		 this.x1=ax;
		 this.y1=ay;
		 this.x2=dx;
		 this.y2=dy;
		 this.val=xvalue;
		 this.cor=xcolor;
		 this.name=xname;
		 this.eventtype=xtype;
		 this.eventtab=xtab;
	 }
	 
	 public Forma(int ax,int ay,int dx,int dy,int xvalue,int xtype,String xtab) {
		 this.x1=ax;
		 this.y1=ay;
		 this.x2=dx;
		 this.y2=dy;
		 this.val=xvalue;	  
		 this.eventtype=xtype;
		 this.eventtab=xtab;
	 }	  
	 
	 public Forma(int ax,int ay,int xvalue, Color xcolor,String xname )  {
		 this.x1=ax;
		 this.y1=ay;
		 this.val=xvalue;
		 this.cor=xcolor;
		 this.name=xname;
	 }
	 public Object clone()
	 {
		 try{
			 return super.clone();
		 } catch (CloneNotSupportedException e)  {
			 return null;
		 }	
		 
	 }	  
	 public void setEvent(int xvalue,String xname, Color xcolor) {
		 this.val=xvalue;
		 this.name=xname;	
		 this.cor=xcolor;  	
	 }	
	 
	 public int getValue() {
		 return this.val;
	 }
	 
	 public Color getColor() {
		 return this.cor;
	 }
	 
	 public String getName() {
		 return this.name;
	 }            
	 
	 public void Point(int ax,int ay,int dx,int dy)  {
		 this.x1=ax;
		 this.y1=ay;
		 this.x2=dx;
		 this.y2=dy;	  
	 }
	 
	 public void PontoFinal( int x2, int y2) {
		 this.x2 = x2;
		 this.y2 = y2;
	 }  
	 
	 public void InitialPoint( int x1, int y1) {
		 this.x1 = x1;
		 this.y1 = y1;
	 }     
	 public void Desenha(Graphics g){
		 if (this.selecionado){
			 g.setColor(cor);	
			 g.fillRect( this.x1-6, this.y1-3, 6,6);
			 g.fillRect( this.x2, this.y2-3, 6,6);   	    
			 g.fillRect( this.x1-6, this.y2-3, 6,6);
			 g.fillRect( this.x2, this.y1-3, 6,6);
		 }	
		 if (this.eventtype==1) {// exit event   		    
			 g.drawString("Exit",this.x1+05, this.y1+10);
			 g.drawLine( this.x1, this.y1,this.x2, this.y2);	
			 g.drawLine( this.x2, this.y1,this.x1, this.y2);	
		 }else if (this.eventtype==2){
			 //g.drawString("Skin "+eventtab,this.x1+05, this.y1+10);	   		 	
			 g.drawLine(this.x1+((this.x2-this.x1)/2), this.y1,this.x1+((this.x2-this.x1)/2), this.y2);	
			 g.drawLine( this.x1, this.y1+(this.y2-this.y1)/2,this.x2,this.y1+(this.y2-this.y1)/2);	
		 }else if (this.eventtype==3){
			 g.drawString("Position",this.x1+05, this.y1+10);	   			
			 //g.draw3DRect(this.x1+5, this.y1+5,this.x2-15, this.y2-20,true);
		 }			 
	 }	
	 
	 public boolean Selected(int x1, int y1, int x2, int y2, int x, int y){
		 if (x2>x1)	{
			 if (x >= x1 & x2>=x){	
				 if (y2>y1){
					 if (y >=y1 &y2>=y)
						 return true;
				 }	 
				 else if (y >=y2 & y1>=y)
					 return true;
			 }
		 }
		 else if (x >=x2 & x1>=x){
			 if (y1>y2) 	{
				 if (y >= y2 & y1>=y)
					 return true;
			 }	 
			 else if (y >= y1 &y2>=y)
				 return true;  		  	 		 
		 }	  		
		 return false;
	 }       
	 abstract public boolean Selecionado(int x,int y);	
	 abstract public int Resize(int x, int y);		
	 abstract public String Description();	
	 abstract public String getDescription();
	 abstract public String getObject();
 }	