 /**
 *   GEditor - a interface generator for PDA Glass application
 * Marcelo de Paiva Guimaraes and Bruno Barberi Gnecco
 * Copyright (C) 2003,2004
 * 
 *  It is part of Glass - a distributed computing library
 *  
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License as published by the Free Software Foundation; either
 *  version 2 of the License, or (at your option) any later version.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 *  @author      Marcelo de Paiva Guimaraes
 *  @version     %I%, %G%
 *  @since       1.0
 */
 import java.awt.*;
 public class Rectangle extends Forma {
	 private int x,y,m,n;	
	 
	 public Rectangle(int ax,int ay,int dx,int dy,int xval,Color xcor,String xname,int xtype,String xtab) {
		 super(ax,ay,dx,dy,xval,xcor,xname,xtype,xtab);
		 type="R";
	 }
	 
	 public Rectangle(int ax,int ay,int dx,int dy,int xval,int xtype,String xtab) {
		 super(ax,ay,dx,dy,xval,xtype,xtab);
		 type="R";
	 }
	 
	 public String getObject()  {
		 return "Rectangle("+x1+","+y1+","+x2+","+y2+")"; 
	 } 	 	
	 
	 public String Description()  { 
		 return "Rectangle;"+x1+";"+y1+";"+x2+";"+y2+";"+val+";"+cor+";"+name+";"+eventtype+";"+eventtab; 
	 }	
	 
	 public String getDescription() { 
		 return "Rectangle("+x1+","+y1+","+x2+","+y2+")";  
	 }
	 
	 public void Desenha(Graphics g) {
		 super.Desenha(g);   	
		 if (this.x2>this.x1)  {
			 m=this.x2-this.x1;
			 x=this.x1;
		 } else {
			 m=this.x1-this.x2;
			 x=this.x2;
		 }
		 if (this.y2>this.y1) {
			 y=this.y1;
			 n=this.y2-this.y1;
		 } else {
			 n=this.y1-this.y2;
			 y=this.y2;
		 }
		 Graphics2D g2 = (Graphics2D) g;
		 g2.setColor(cor);
		 AlphaComposite ac = 	AlphaComposite.getInstance(AlphaComposite.SRC_OVER,0.5f);		 
		 g2.setComposite(ac);
		 g2.fillRect(x,y,m, n);		 	 
	 }	
	 
	 public int Resize(int x, int y) { 		 	 
		 if (this.Selected( this.x1-6, this.y1-3,this.x1,this.y1,x,y))
			 return 1; // 1-left upper
		 if (this.Selected( this.x2, this.y2-3,this.x2+6,this.y2+6,x,y))   	    
			 return 2;  //  2-right downer
		 if (this.Selected( this.x1-6, this.y2-3,this.x2+6,this.y2+6,x,y))
			 return 3; // 3-left down 
		 if (this.Selected( this.x2, this.y1-3,this.x2+6,this.y2+6,x,y))
			 return 4;  //  4-right upper
		 return 0;	// 0-nothing
	 }
	 
	 public boolean Selecionado (int x, int y)  {
		 return Selected(this.x1,this.y1,this.x2,this.y2,x,y);		
	 }	
 }