/**
 *   GTracer - Log Viewer - a libGlass Tool
 * Marcelo de Paiva Guimaraes and Bruno Barberi Gnecco
 * Copyright (C) 2003,2004
 * 
 *  It is part of Glass - a distributed computing library
 *  
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License as published by the Free Software Foundation; either
 *  version 2 of the License, or (at your option) any later version.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 *  @author      Marcelo de Paiva Guimaraes
 *  @version     %I%, %G%
 *  @since       1.0
*/
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.border.*;
import java.io.*;
import java.util.*;

public class GFrame extends JFrame {
	JPanel contentPane;
	JLabel jLabel1 = new JLabel();
	JButton jBExit = new JButton();
	JLabel jLabel2 = new JLabel();
	TitledBorder titledBorder1;
	JPanel jPanel1 = new JPanel();
	JList jList1;// = new JList();
	JButton jBUpdate = new JButton();
	Vector xfiles = new Vector();

	// Construct the frame
	public GFrame() {
		enableEvents(AWTEvent.WINDOW_EVENT_MASK);
		try {
			jbInit();
		} catch (Exception e) {
			e.printStackTrace();
		}
	}

	// Component initialization
	private void jbInit() throws Exception {
		jList1 = new JList(xfiles);
		Update_list();
		contentPane = (JPanel) this.getContentPane();
		titledBorder1 = new TitledBorder("");
		jLabel1.setFont(new java.awt.Font("SansSerif", 1, 20));
		jLabel1.setForeground(SystemColor.desktop);
		jLabel1.setText("libGlass Tool");
		jLabel1.setBounds(new Rectangle(52, 7, 151, 26));
		contentPane.setLayout(null);
		this.setSize(new Dimension(360, 353));
		this.setTitle("libGlass Tool - GTracer");
		jBExit.setBounds(new Rectangle(124, 279, 75, 26));
		jBExit.setText("Exit");
		jBExit.addActionListener(new GFrame_jBExit_actionAdapter(this));
		// contentPane.setVerifyInputWhenFocusTarget(true);
		jLabel2.setFont(new java.awt.Font("Dialog", 1, 15));
		jLabel2.setText("Tracer");
		jLabel2.setBounds(new Rectangle(77, 30, 169, 26));
		jPanel1.setBackground(UIManager.getColor("control"));
		jPanel1.setBorder(BorderFactory.createEtchedBorder());
		jPanel1.setBounds(new Rectangle(13, 57, 297, 215));
		jList1.setMaximumSize(new Dimension(50, 100));
		jList1.setPreferredSize(new Dimension(270, 200));
		jList1.addMouseListener(new GFrame_jList1_mouseAdapter(this));
		jBUpdate.setBounds(new Rectangle(16, 280, 97, 23));
		jBUpdate.setText("Update");
		jBUpdate.addActionListener(new GFrame_jBUpdate_actionAdapter(this));
		contentPane.add(jLabel1, null);
		contentPane.add(jLabel2, null);
		contentPane.add(jPanel1, null);
		jPanel1.add(jList1, null);
		contentPane.add(jBExit, null);
		contentPane.add(jBUpdate, null);

	}

	// Overridden so we can exit when window is closed
	protected void processWindowEvent(WindowEvent e) {
		super.processWindowEvent(e);
		if (e.getID() == WindowEvent.WINDOW_CLOSING) {
			System.exit(0);
		}
	}

	void jBExit_actionPerformed(ActionEvent e) {
		System.exit(0);
	}

	void Update_list() {
		String[] filenames;
		// filenames=null;
		File f = new File(".");
		filenames = f.list();
		xfiles.clear();
		for (int i = 0; i < filenames.length; i++) {
			if (filenames[i].endsWith(".log"))
				xfiles.add(filenames[i]);
		}
		jList1.updateUI();
		repaint();
		// jList1 = new JList(xfiles);
		// jList1.addMouseListener(new GFrame_jList1_mouseAdapter(this));
	}

	void jBUpdate_actionPerformed(ActionEvent e) {
		Update_list();
	}

	void jList1_mouseClicked(MouseEvent e) {
		if (e.getClickCount() == 2) {
			// System.out.println("clicou ");
			Object[] FilterValues = jList1.getSelectedValues();
			if (!(FilterValues.length == 0))
				new Trace((String) FilterValues[0]);
		}
	}
}

class GFrame_jBExit_actionAdapter implements java.awt.event.ActionListener {
	GFrame adaptee;

	GFrame_jBExit_actionAdapter(GFrame adaptee) {
		this.adaptee = adaptee;
	}

	public void actionPerformed(ActionEvent e) {
		adaptee.jBExit_actionPerformed(e);
	}
}

class GFrame_jBUpdate_actionAdapter implements java.awt.event.ActionListener {
	GFrame adaptee;

	GFrame_jBUpdate_actionAdapter(GFrame adaptee) {
		this.adaptee = adaptee;
	}

	public void actionPerformed(ActionEvent e) {
		adaptee.jBUpdate_actionPerformed(e);
	}
}

class GFrame_jList1_mouseAdapter extends java.awt.event.MouseAdapter {
	GFrame adaptee;

	GFrame_jList1_mouseAdapter(GFrame adaptee) {
		this.adaptee = adaptee;
	}

	public void mouseClicked(MouseEvent e) {
		adaptee.jList1_mouseClicked(e);
	}
}