/**
 *   GTracer - Log Viewer - a libGlass Tool
 * Marcelo de Paiva Guimaraes and Bruno Barberi Gnecco
 * Copyright (C) 2003,2004
 * 
 *  It is part of Glass - a distributed computing library
 *  
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License as published by the Free Software Foundation; either
 *  version 2 of the License, or (at your option) any later version.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 *  @author      Marcelo de Paiva Guimaraes
 *  @version     %I%, %G%
 *  @since       1.0
*/

public class Message {
	private char type; // S - Sent or G = Got
	private Host host; // host number
	private String msg; // packet message

	Message(char t, Host h, String m) {
		this.type = t;
		this.host = h;
		this.msg = m;
	}

	char getType() // return the type - Sent or G = Got
	{
		return type;
	}

	String getMsg() // return the message that will be present on the narrow (at
					// screen)
	{
		return msg;
	}

	int getPosition() // return the draw positon of the node of this message
	{
		return host.getPosition();
	}

}