/**
 *   GTracer - Log Viewer - a libGlass Tool
 * Marcelo de Paiva Guimaraes and Bruno Barberi Gnecco
 * Copyright (C) 2003,2004
 * 
 *  It is part of Glass - a distributed computing library
 *  
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License as published by the Free Software Foundation; either
 *  version 2 of the License, or (at your option) any later version.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 *  @author      Marcelo de Paiva Guimaraes
 *  @version     %I%, %G%
 *  @since       1.0
*/

import java.io.*;
import java.util.*;

public class ReaderLog implements Runnable {
	Frame1 frm;
	boolean Status;
	String filename;

	public ReaderLog(Frame1 f, String xf) {
		frm = f;
		filename = xf;
	}

	public void setStatus(boolean s) {
		Status = s;
	}

	public void run() {
		Status = true;
		String xline = "", xmsg = "", xhost = "";
		char xtype = ' ';
		int quant = 0;
		try {
			FileInputStream file = new FileInputStream(filename);
			int input = 0;
			int xsearch = 0;// 1-searching type 2-searching msg 3-searching host
			boolean xadd;
			Host tmp = null;
			Enumeration e;
			while (input != -1) {
				if (!Status)
					return;
				input = file.read();
				xline = xline + (char) input;
				frm.xfile = frm.xfile + (char) input;
				if ((char) input == '[')
					quant++;
				if (quant == 1 && (char) input == ']')
					xsearch = 1;
				else if (input == 10) {
					if (quant == 3)// with 3 ']' is a valid message
					{
						e = frm.listmsg.elements();
						xadd = true;
						String xstr;
						while (e.hasMoreElements() && xadd) {
							xstr = (String) e.nextElement();
							if (xstr.equals(xmsg))
								xadd = false;
						}
						if (xadd)
							frm.listmsg.add(xmsg);
						e = frm.nodes.elements();
						xadd = true;
						while (e.hasMoreElements() && xadd) // search the node
															// (host)
						{
							tmp = (Host) e.nextElement();
							if (tmp.getId() == Integer.valueOf(xhost)
									.intValue())
								xadd = false;
						}
						if (xadd) // if the node is not found it is added
						{
							tmp = new Host(Integer.valueOf(xhost).intValue());
							frm.nodes.add(tmp);
						}
						frm.msg.add(new Message(xtype, tmp, xmsg));
					}
					frm.repaint();
					xline = "";
					xtype = ' ';
					xmsg = "";
					xhost = "";
					quant = 0;
				} else if (xsearch == 1) {
					if ((char) input == 'S') {
						xtype = 'S'; // sent
						xsearch = 2;
					} else if ((char) input == 'G') {
						xtype = 'G'; // got
						xsearch = 2;
					}
				} else if (xsearch == 2) {
					if ((char) input == ']')
						xsearch = 3;
					else if ((char) input == '[')
						xmsg = "";
					else
						xmsg = xmsg + (char) input;
				} else if (xsearch == 3) {
					if ((char) input == ']')
						xsearch = 0;
					else if ((char) input == '[')
						xhost = "";
					else
						xhost = xhost + (char) input;
				}
			}
			file.close();
		} catch (IOException ex) {
			System.out.println("Erro: " + ex.toString());
		}
	}
}
